// A Bison parser, made by GNU Bison 3.8.2.

// Skeleton implementation for Bison LALR(1) parsers in C++

// Copyright (C) 2002-2015, 2018-2021 Free Software Foundation, Inc.

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <https://www.gnu.org/licenses/>.

// As a special exception, you may create a larger work that contains
// part or all of the Bison parser skeleton and distribute that work
// under terms of your choice, so long as that work isn't itself a
// parser generator using the skeleton or a modified version thereof
// as a parser skeleton.  Alternatively, if you modify or redistribute
// the parser skeleton itself, you may (at your option) remove this
// special exception, which will cause the skeleton and the resulting
// Bison output files to be licensed under the GNU General Public
// License without this special exception.

// This special exception was added by the Free Software Foundation in
// version 2.2 of Bison.

// DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
// especially those whose name start with YY_ or yy_.  They are
// private implementation details that can be changed or removed.



// First part of user prologue.
#line 37 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"

#include <iostream>

#include "driver.h"
#include "lexer.h"

void yyerror(bpftrace::Driver &driver, const char *s);

#line 50 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"


#include "parser.tab.hh"




#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> // FIXME: INFRINGES ON USER NAME SPACE.
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif


// Whether we are compiled with exception support.
#ifndef YY_EXCEPTIONS
# if defined __GNUC__ && !defined __EXCEPTIONS
#  define YY_EXCEPTIONS 0
# else
#  define YY_EXCEPTIONS 1
# endif
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K].location)
/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

# ifndef YYLLOC_DEFAULT
#  define YYLLOC_DEFAULT(Current, Rhs, N)                               \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).begin  = YYRHSLOC (Rhs, 1).begin;                   \
          (Current).end    = YYRHSLOC (Rhs, N).end;                     \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).begin = (Current).end = YYRHSLOC (Rhs, 0).end;      \
        }                                                               \
    while (false)
# endif


// Enable debugging if requested.
#if YYDEBUG

// A pseudo ostream that takes yydebug_ into account.
# define YYCDEBUG if (yydebug_) (*yycdebug_)

# define YY_SYMBOL_PRINT(Title, Symbol)         \
  do {                                          \
    if (yydebug_)                               \
    {                                           \
      *yycdebug_ << Title << ' ';               \
      yy_print_ (*yycdebug_, Symbol);           \
      *yycdebug_ << '\n';                       \
    }                                           \
  } while (false)

# define YY_REDUCE_PRINT(Rule)          \
  do {                                  \
    if (yydebug_)                       \
      yy_reduce_print_ (Rule);          \
  } while (false)

# define YY_STACK_PRINT()               \
  do {                                  \
    if (yydebug_)                       \
      yy_stack_print_ ();                \
  } while (false)

#else // !YYDEBUG

# define YYCDEBUG if (false) std::cerr
# define YY_SYMBOL_PRINT(Title, Symbol)  YY_USE (Symbol)
# define YY_REDUCE_PRINT(Rule)           static_cast<void> (0)
# define YY_STACK_PRINT()                static_cast<void> (0)

#endif // !YYDEBUG

#define yyerrok         (yyerrstatus_ = 0)
#define yyclearin       (yyla.clear ())

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYRECOVERING()  (!!yyerrstatus_)

#line 4 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
namespace  bpftrace  {
#line 148 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"

  /// Build a parser object.
  Parser::Parser (bpftrace::Driver &driver_yyarg, void *yyscanner_yyarg)
#if YYDEBUG
    : yydebug_ (false),
      yycdebug_ (&std::cerr),
#else
    :
#endif
      driver (driver_yyarg),
      yyscanner (yyscanner_yyarg)
  {}

  Parser::~Parser ()
  {}

  Parser::syntax_error::~syntax_error () YY_NOEXCEPT YY_NOTHROW
  {}

  /*---------.
  | symbol.  |
  `---------*/



  // by_state.
  Parser::by_state::by_state () YY_NOEXCEPT
    : state (empty_state)
  {}

  Parser::by_state::by_state (const by_state& that) YY_NOEXCEPT
    : state (that.state)
  {}

  void
  Parser::by_state::clear () YY_NOEXCEPT
  {
    state = empty_state;
  }

  void
  Parser::by_state::move (by_state& that)
  {
    state = that.state;
    that.clear ();
  }

  Parser::by_state::by_state (state_type s) YY_NOEXCEPT
    : state (s)
  {}

  Parser::symbol_kind_type
  Parser::by_state::kind () const YY_NOEXCEPT
  {
    if (state == empty_state)
      return symbol_kind::S_YYEMPTY;
    else
      return YY_CAST (symbol_kind_type, yystos_[+state]);
  }

  Parser::stack_symbol_type::stack_symbol_type ()
  {}

  Parser::stack_symbol_type::stack_symbol_type (YY_RVREF (stack_symbol_type) that)
    : super_type (YY_MOVE (that.state), YY_MOVE (that.location))
  {
    switch (that.kind ())
    {
      case symbol_kind::S_type: // type
      case symbol_kind::S_int_type: // int_type
      case symbol_kind::S_pointer_type: // pointer_type
      case symbol_kind::S_struct_type: // struct_type
        value.YY_MOVE_OR_COPY< SizedType > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_attach_point: // attach_point
        value.YY_MOVE_OR_COPY< ast::AttachPoint * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_attach_points: // attach_points
        value.YY_MOVE_OR_COPY< ast::AttachPointList > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_call: // call
        value.YY_MOVE_OR_COPY< ast::Call * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_config: // config
        value.YY_MOVE_OR_COPY< ast::Config * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_primary_expr: // primary_expr
      case symbol_kind::S_postfix_expr: // postfix_expr
      case symbol_kind::S_tuple_access_expr: // tuple_access_expr
      case symbol_kind::S_unary_expr: // unary_expr
      case symbol_kind::S_expr: // expr
      case symbol_kind::S_conditional_expr: // conditional_expr
      case symbol_kind::S_logical_or_expr: // logical_or_expr
      case symbol_kind::S_logical_and_expr: // logical_and_expr
      case symbol_kind::S_or_expr: // or_expr
      case symbol_kind::S_xor_expr: // xor_expr
      case symbol_kind::S_and_expr: // and_expr
      case symbol_kind::S_equality_expr: // equality_expr
      case symbol_kind::S_relational_expr: // relational_expr
      case symbol_kind::S_shift_expr: // shift_expr
      case symbol_kind::S_muli_expr: // muli_expr
      case symbol_kind::S_addi_expr: // addi_expr
      case symbol_kind::S_cast_expr: // cast_expr
      case symbol_kind::S_map_or_var: // map_or_var
        value.YY_MOVE_OR_COPY< ast::Expression * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_vargs: // vargs
        value.YY_MOVE_OR_COPY< ast::ExpressionList > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_int: // int
        value.YY_MOVE_OR_COPY< ast::Integer * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_map: // map
        value.YY_MOVE_OR_COPY< ast::Map * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_offsetof_expr: // offsetof_expr
        value.YY_MOVE_OR_COPY< ast::Offsetof * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_unary_op: // unary_op
      case symbol_kind::S_compound_op: // compound_op
        value.YY_MOVE_OR_COPY< ast::Operator > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_param: // param
        value.YY_MOVE_OR_COPY< ast::PositionalParameter * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_pred: // pred
        value.YY_MOVE_OR_COPY< ast::Predicate * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_probe: // probe
        value.YY_MOVE_OR_COPY< ast::Probe * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_sizeof_expr: // sizeof_expr
        value.YY_MOVE_OR_COPY< ast::Sizeof * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_config_assign_stmt: // config_assign_stmt
      case symbol_kind::S_block_stmt: // block_stmt
      case symbol_kind::S_expr_stmt: // expr_stmt
      case symbol_kind::S_jump_stmt: // jump_stmt
      case symbol_kind::S_loop_stmt: // loop_stmt
      case symbol_kind::S_for_stmt: // for_stmt
      case symbol_kind::S_if_stmt: // if_stmt
      case symbol_kind::S_assign_stmt: // assign_stmt
        value.YY_MOVE_OR_COPY< ast::Statement * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_config_block: // config_block
      case symbol_kind::S_config_assign_stmt_list: // config_assign_stmt_list
      case symbol_kind::S_block: // block
      case symbol_kind::S_stmt_list: // stmt_list
      case symbol_kind::S_block_or_if: // block_or_if
        value.YY_MOVE_OR_COPY< ast::StatementList > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_subprog: // subprog
        value.YY_MOVE_OR_COPY< ast::Subprog * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_subprog_arg: // subprog_arg
        value.YY_MOVE_OR_COPY< ast::SubprogArg * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_subprog_args: // subprog_args
        value.YY_MOVE_OR_COPY< ast::SubprogArgList > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_var_decl_stmt: // var_decl_stmt
        value.YY_MOVE_OR_COPY< ast::VarDeclStatement * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_var: // var
        value.YY_MOVE_OR_COPY< ast::Variable * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_INT: // "integer"
        value.YY_MOVE_OR_COPY< int64_t > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_probes_and_subprogs: // probes_and_subprogs
        value.YY_MOVE_OR_COPY< std::pair<ast::ProbeList, ast::SubprogList> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_BUILTIN: // "builtin"
      case symbol_kind::S_CALL: // "call"
      case symbol_kind::S_CALL_BUILTIN: // "call_builtin"
      case symbol_kind::S_INT_TYPE: // "integer type"
      case symbol_kind::S_BUILTIN_TYPE: // "builtin type"
      case symbol_kind::S_SUBPROG: // "subprog"
      case symbol_kind::S_SIZED_TYPE: // "sized type"
      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_PATH: // "path"
      case symbol_kind::S_CPREPROC: // "preprocessor directive"
      case symbol_kind::S_STRUCT_DEFN: // "struct definition"
      case symbol_kind::S_ENUM: // "enum"
      case symbol_kind::S_STRING: // "string"
      case symbol_kind::S_MAP: // "map"
      case symbol_kind::S_VAR: // "variable"
      case symbol_kind::S_PARAM: // "positional parameter"
      case symbol_kind::S_STACK_MODE: // "stack_mode"
      case symbol_kind::S_CONFIG: // "config"
      case symbol_kind::S_UNROLL: // "unroll"
      case symbol_kind::S_WHILE: // "while"
      case symbol_kind::S_FOR: // "for"
      case symbol_kind::S_RETURN: // "return"
      case symbol_kind::S_IF: // "if"
      case symbol_kind::S_ELSE: // "else"
      case symbol_kind::S_CONTINUE: // "continue"
      case symbol_kind::S_BREAK: // "break"
      case symbol_kind::S_SIZEOF: // "sizeof"
      case symbol_kind::S_OFFSETOF: // "offsetof"
      case symbol_kind::S_LET: // "let"
      case symbol_kind::S_c_definitions: // c_definitions
      case symbol_kind::S_attach_point_def: // attach_point_def
      case symbol_kind::S_keyword: // keyword
      case symbol_kind::S_ident: // ident
      case symbol_kind::S_external_name: // external_name
        value.YY_MOVE_OR_COPY< std::string > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_struct_field: // struct_field
        value.YY_MOVE_OR_COPY< std::vector<std::string> > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

#if 201103L <= YY_CPLUSPLUS
    // that is emptied.
    that.state = empty_state;
#endif
  }

  Parser::stack_symbol_type::stack_symbol_type (state_type s, YY_MOVE_REF (symbol_type) that)
    : super_type (s, YY_MOVE (that.location))
  {
    switch (that.kind ())
    {
      case symbol_kind::S_type: // type
      case symbol_kind::S_int_type: // int_type
      case symbol_kind::S_pointer_type: // pointer_type
      case symbol_kind::S_struct_type: // struct_type
        value.move< SizedType > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_attach_point: // attach_point
        value.move< ast::AttachPoint * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_attach_points: // attach_points
        value.move< ast::AttachPointList > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_call: // call
        value.move< ast::Call * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_config: // config
        value.move< ast::Config * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_primary_expr: // primary_expr
      case symbol_kind::S_postfix_expr: // postfix_expr
      case symbol_kind::S_tuple_access_expr: // tuple_access_expr
      case symbol_kind::S_unary_expr: // unary_expr
      case symbol_kind::S_expr: // expr
      case symbol_kind::S_conditional_expr: // conditional_expr
      case symbol_kind::S_logical_or_expr: // logical_or_expr
      case symbol_kind::S_logical_and_expr: // logical_and_expr
      case symbol_kind::S_or_expr: // or_expr
      case symbol_kind::S_xor_expr: // xor_expr
      case symbol_kind::S_and_expr: // and_expr
      case symbol_kind::S_equality_expr: // equality_expr
      case symbol_kind::S_relational_expr: // relational_expr
      case symbol_kind::S_shift_expr: // shift_expr
      case symbol_kind::S_muli_expr: // muli_expr
      case symbol_kind::S_addi_expr: // addi_expr
      case symbol_kind::S_cast_expr: // cast_expr
      case symbol_kind::S_map_or_var: // map_or_var
        value.move< ast::Expression * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_vargs: // vargs
        value.move< ast::ExpressionList > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_int: // int
        value.move< ast::Integer * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_map: // map
        value.move< ast::Map * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_offsetof_expr: // offsetof_expr
        value.move< ast::Offsetof * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_unary_op: // unary_op
      case symbol_kind::S_compound_op: // compound_op
        value.move< ast::Operator > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_param: // param
        value.move< ast::PositionalParameter * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_pred: // pred
        value.move< ast::Predicate * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_probe: // probe
        value.move< ast::Probe * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_sizeof_expr: // sizeof_expr
        value.move< ast::Sizeof * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_config_assign_stmt: // config_assign_stmt
      case symbol_kind::S_block_stmt: // block_stmt
      case symbol_kind::S_expr_stmt: // expr_stmt
      case symbol_kind::S_jump_stmt: // jump_stmt
      case symbol_kind::S_loop_stmt: // loop_stmt
      case symbol_kind::S_for_stmt: // for_stmt
      case symbol_kind::S_if_stmt: // if_stmt
      case symbol_kind::S_assign_stmt: // assign_stmt
        value.move< ast::Statement * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_config_block: // config_block
      case symbol_kind::S_config_assign_stmt_list: // config_assign_stmt_list
      case symbol_kind::S_block: // block
      case symbol_kind::S_stmt_list: // stmt_list
      case symbol_kind::S_block_or_if: // block_or_if
        value.move< ast::StatementList > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_subprog: // subprog
        value.move< ast::Subprog * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_subprog_arg: // subprog_arg
        value.move< ast::SubprogArg * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_subprog_args: // subprog_args
        value.move< ast::SubprogArgList > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_var_decl_stmt: // var_decl_stmt
        value.move< ast::VarDeclStatement * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_var: // var
        value.move< ast::Variable * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_INT: // "integer"
        value.move< int64_t > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_probes_and_subprogs: // probes_and_subprogs
        value.move< std::pair<ast::ProbeList, ast::SubprogList> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_BUILTIN: // "builtin"
      case symbol_kind::S_CALL: // "call"
      case symbol_kind::S_CALL_BUILTIN: // "call_builtin"
      case symbol_kind::S_INT_TYPE: // "integer type"
      case symbol_kind::S_BUILTIN_TYPE: // "builtin type"
      case symbol_kind::S_SUBPROG: // "subprog"
      case symbol_kind::S_SIZED_TYPE: // "sized type"
      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_PATH: // "path"
      case symbol_kind::S_CPREPROC: // "preprocessor directive"
      case symbol_kind::S_STRUCT_DEFN: // "struct definition"
      case symbol_kind::S_ENUM: // "enum"
      case symbol_kind::S_STRING: // "string"
      case symbol_kind::S_MAP: // "map"
      case symbol_kind::S_VAR: // "variable"
      case symbol_kind::S_PARAM: // "positional parameter"
      case symbol_kind::S_STACK_MODE: // "stack_mode"
      case symbol_kind::S_CONFIG: // "config"
      case symbol_kind::S_UNROLL: // "unroll"
      case symbol_kind::S_WHILE: // "while"
      case symbol_kind::S_FOR: // "for"
      case symbol_kind::S_RETURN: // "return"
      case symbol_kind::S_IF: // "if"
      case symbol_kind::S_ELSE: // "else"
      case symbol_kind::S_CONTINUE: // "continue"
      case symbol_kind::S_BREAK: // "break"
      case symbol_kind::S_SIZEOF: // "sizeof"
      case symbol_kind::S_OFFSETOF: // "offsetof"
      case symbol_kind::S_LET: // "let"
      case symbol_kind::S_c_definitions: // c_definitions
      case symbol_kind::S_attach_point_def: // attach_point_def
      case symbol_kind::S_keyword: // keyword
      case symbol_kind::S_ident: // ident
      case symbol_kind::S_external_name: // external_name
        value.move< std::string > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_struct_field: // struct_field
        value.move< std::vector<std::string> > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

    // that is emptied.
    that.kind_ = symbol_kind::S_YYEMPTY;
  }

#if YY_CPLUSPLUS < 201103L
  Parser::stack_symbol_type&
  Parser::stack_symbol_type::operator= (const stack_symbol_type& that)
  {
    state = that.state;
    switch (that.kind ())
    {
      case symbol_kind::S_type: // type
      case symbol_kind::S_int_type: // int_type
      case symbol_kind::S_pointer_type: // pointer_type
      case symbol_kind::S_struct_type: // struct_type
        value.copy< SizedType > (that.value);
        break;

      case symbol_kind::S_attach_point: // attach_point
        value.copy< ast::AttachPoint * > (that.value);
        break;

      case symbol_kind::S_attach_points: // attach_points
        value.copy< ast::AttachPointList > (that.value);
        break;

      case symbol_kind::S_call: // call
        value.copy< ast::Call * > (that.value);
        break;

      case symbol_kind::S_config: // config
        value.copy< ast::Config * > (that.value);
        break;

      case symbol_kind::S_primary_expr: // primary_expr
      case symbol_kind::S_postfix_expr: // postfix_expr
      case symbol_kind::S_tuple_access_expr: // tuple_access_expr
      case symbol_kind::S_unary_expr: // unary_expr
      case symbol_kind::S_expr: // expr
      case symbol_kind::S_conditional_expr: // conditional_expr
      case symbol_kind::S_logical_or_expr: // logical_or_expr
      case symbol_kind::S_logical_and_expr: // logical_and_expr
      case symbol_kind::S_or_expr: // or_expr
      case symbol_kind::S_xor_expr: // xor_expr
      case symbol_kind::S_and_expr: // and_expr
      case symbol_kind::S_equality_expr: // equality_expr
      case symbol_kind::S_relational_expr: // relational_expr
      case symbol_kind::S_shift_expr: // shift_expr
      case symbol_kind::S_muli_expr: // muli_expr
      case symbol_kind::S_addi_expr: // addi_expr
      case symbol_kind::S_cast_expr: // cast_expr
      case symbol_kind::S_map_or_var: // map_or_var
        value.copy< ast::Expression * > (that.value);
        break;

      case symbol_kind::S_vargs: // vargs
        value.copy< ast::ExpressionList > (that.value);
        break;

      case symbol_kind::S_int: // int
        value.copy< ast::Integer * > (that.value);
        break;

      case symbol_kind::S_map: // map
        value.copy< ast::Map * > (that.value);
        break;

      case symbol_kind::S_offsetof_expr: // offsetof_expr
        value.copy< ast::Offsetof * > (that.value);
        break;

      case symbol_kind::S_unary_op: // unary_op
      case symbol_kind::S_compound_op: // compound_op
        value.copy< ast::Operator > (that.value);
        break;

      case symbol_kind::S_param: // param
        value.copy< ast::PositionalParameter * > (that.value);
        break;

      case symbol_kind::S_pred: // pred
        value.copy< ast::Predicate * > (that.value);
        break;

      case symbol_kind::S_probe: // probe
        value.copy< ast::Probe * > (that.value);
        break;

      case symbol_kind::S_sizeof_expr: // sizeof_expr
        value.copy< ast::Sizeof * > (that.value);
        break;

      case symbol_kind::S_config_assign_stmt: // config_assign_stmt
      case symbol_kind::S_block_stmt: // block_stmt
      case symbol_kind::S_expr_stmt: // expr_stmt
      case symbol_kind::S_jump_stmt: // jump_stmt
      case symbol_kind::S_loop_stmt: // loop_stmt
      case symbol_kind::S_for_stmt: // for_stmt
      case symbol_kind::S_if_stmt: // if_stmt
      case symbol_kind::S_assign_stmt: // assign_stmt
        value.copy< ast::Statement * > (that.value);
        break;

      case symbol_kind::S_config_block: // config_block
      case symbol_kind::S_config_assign_stmt_list: // config_assign_stmt_list
      case symbol_kind::S_block: // block
      case symbol_kind::S_stmt_list: // stmt_list
      case symbol_kind::S_block_or_if: // block_or_if
        value.copy< ast::StatementList > (that.value);
        break;

      case symbol_kind::S_subprog: // subprog
        value.copy< ast::Subprog * > (that.value);
        break;

      case symbol_kind::S_subprog_arg: // subprog_arg
        value.copy< ast::SubprogArg * > (that.value);
        break;

      case symbol_kind::S_subprog_args: // subprog_args
        value.copy< ast::SubprogArgList > (that.value);
        break;

      case symbol_kind::S_var_decl_stmt: // var_decl_stmt
        value.copy< ast::VarDeclStatement * > (that.value);
        break;

      case symbol_kind::S_var: // var
        value.copy< ast::Variable * > (that.value);
        break;

      case symbol_kind::S_INT: // "integer"
        value.copy< int64_t > (that.value);
        break;

      case symbol_kind::S_probes_and_subprogs: // probes_and_subprogs
        value.copy< std::pair<ast::ProbeList, ast::SubprogList> > (that.value);
        break;

      case symbol_kind::S_BUILTIN: // "builtin"
      case symbol_kind::S_CALL: // "call"
      case symbol_kind::S_CALL_BUILTIN: // "call_builtin"
      case symbol_kind::S_INT_TYPE: // "integer type"
      case symbol_kind::S_BUILTIN_TYPE: // "builtin type"
      case symbol_kind::S_SUBPROG: // "subprog"
      case symbol_kind::S_SIZED_TYPE: // "sized type"
      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_PATH: // "path"
      case symbol_kind::S_CPREPROC: // "preprocessor directive"
      case symbol_kind::S_STRUCT_DEFN: // "struct definition"
      case symbol_kind::S_ENUM: // "enum"
      case symbol_kind::S_STRING: // "string"
      case symbol_kind::S_MAP: // "map"
      case symbol_kind::S_VAR: // "variable"
      case symbol_kind::S_PARAM: // "positional parameter"
      case symbol_kind::S_STACK_MODE: // "stack_mode"
      case symbol_kind::S_CONFIG: // "config"
      case symbol_kind::S_UNROLL: // "unroll"
      case symbol_kind::S_WHILE: // "while"
      case symbol_kind::S_FOR: // "for"
      case symbol_kind::S_RETURN: // "return"
      case symbol_kind::S_IF: // "if"
      case symbol_kind::S_ELSE: // "else"
      case symbol_kind::S_CONTINUE: // "continue"
      case symbol_kind::S_BREAK: // "break"
      case symbol_kind::S_SIZEOF: // "sizeof"
      case symbol_kind::S_OFFSETOF: // "offsetof"
      case symbol_kind::S_LET: // "let"
      case symbol_kind::S_c_definitions: // c_definitions
      case symbol_kind::S_attach_point_def: // attach_point_def
      case symbol_kind::S_keyword: // keyword
      case symbol_kind::S_ident: // ident
      case symbol_kind::S_external_name: // external_name
        value.copy< std::string > (that.value);
        break;

      case symbol_kind::S_struct_field: // struct_field
        value.copy< std::vector<std::string> > (that.value);
        break;

      default:
        break;
    }

    location = that.location;
    return *this;
  }

  Parser::stack_symbol_type&
  Parser::stack_symbol_type::operator= (stack_symbol_type& that)
  {
    state = that.state;
    switch (that.kind ())
    {
      case symbol_kind::S_type: // type
      case symbol_kind::S_int_type: // int_type
      case symbol_kind::S_pointer_type: // pointer_type
      case symbol_kind::S_struct_type: // struct_type
        value.move< SizedType > (that.value);
        break;

      case symbol_kind::S_attach_point: // attach_point
        value.move< ast::AttachPoint * > (that.value);
        break;

      case symbol_kind::S_attach_points: // attach_points
        value.move< ast::AttachPointList > (that.value);
        break;

      case symbol_kind::S_call: // call
        value.move< ast::Call * > (that.value);
        break;

      case symbol_kind::S_config: // config
        value.move< ast::Config * > (that.value);
        break;

      case symbol_kind::S_primary_expr: // primary_expr
      case symbol_kind::S_postfix_expr: // postfix_expr
      case symbol_kind::S_tuple_access_expr: // tuple_access_expr
      case symbol_kind::S_unary_expr: // unary_expr
      case symbol_kind::S_expr: // expr
      case symbol_kind::S_conditional_expr: // conditional_expr
      case symbol_kind::S_logical_or_expr: // logical_or_expr
      case symbol_kind::S_logical_and_expr: // logical_and_expr
      case symbol_kind::S_or_expr: // or_expr
      case symbol_kind::S_xor_expr: // xor_expr
      case symbol_kind::S_and_expr: // and_expr
      case symbol_kind::S_equality_expr: // equality_expr
      case symbol_kind::S_relational_expr: // relational_expr
      case symbol_kind::S_shift_expr: // shift_expr
      case symbol_kind::S_muli_expr: // muli_expr
      case symbol_kind::S_addi_expr: // addi_expr
      case symbol_kind::S_cast_expr: // cast_expr
      case symbol_kind::S_map_or_var: // map_or_var
        value.move< ast::Expression * > (that.value);
        break;

      case symbol_kind::S_vargs: // vargs
        value.move< ast::ExpressionList > (that.value);
        break;

      case symbol_kind::S_int: // int
        value.move< ast::Integer * > (that.value);
        break;

      case symbol_kind::S_map: // map
        value.move< ast::Map * > (that.value);
        break;

      case symbol_kind::S_offsetof_expr: // offsetof_expr
        value.move< ast::Offsetof * > (that.value);
        break;

      case symbol_kind::S_unary_op: // unary_op
      case symbol_kind::S_compound_op: // compound_op
        value.move< ast::Operator > (that.value);
        break;

      case symbol_kind::S_param: // param
        value.move< ast::PositionalParameter * > (that.value);
        break;

      case symbol_kind::S_pred: // pred
        value.move< ast::Predicate * > (that.value);
        break;

      case symbol_kind::S_probe: // probe
        value.move< ast::Probe * > (that.value);
        break;

      case symbol_kind::S_sizeof_expr: // sizeof_expr
        value.move< ast::Sizeof * > (that.value);
        break;

      case symbol_kind::S_config_assign_stmt: // config_assign_stmt
      case symbol_kind::S_block_stmt: // block_stmt
      case symbol_kind::S_expr_stmt: // expr_stmt
      case symbol_kind::S_jump_stmt: // jump_stmt
      case symbol_kind::S_loop_stmt: // loop_stmt
      case symbol_kind::S_for_stmt: // for_stmt
      case symbol_kind::S_if_stmt: // if_stmt
      case symbol_kind::S_assign_stmt: // assign_stmt
        value.move< ast::Statement * > (that.value);
        break;

      case symbol_kind::S_config_block: // config_block
      case symbol_kind::S_config_assign_stmt_list: // config_assign_stmt_list
      case symbol_kind::S_block: // block
      case symbol_kind::S_stmt_list: // stmt_list
      case symbol_kind::S_block_or_if: // block_or_if
        value.move< ast::StatementList > (that.value);
        break;

      case symbol_kind::S_subprog: // subprog
        value.move< ast::Subprog * > (that.value);
        break;

      case symbol_kind::S_subprog_arg: // subprog_arg
        value.move< ast::SubprogArg * > (that.value);
        break;

      case symbol_kind::S_subprog_args: // subprog_args
        value.move< ast::SubprogArgList > (that.value);
        break;

      case symbol_kind::S_var_decl_stmt: // var_decl_stmt
        value.move< ast::VarDeclStatement * > (that.value);
        break;

      case symbol_kind::S_var: // var
        value.move< ast::Variable * > (that.value);
        break;

      case symbol_kind::S_INT: // "integer"
        value.move< int64_t > (that.value);
        break;

      case symbol_kind::S_probes_and_subprogs: // probes_and_subprogs
        value.move< std::pair<ast::ProbeList, ast::SubprogList> > (that.value);
        break;

      case symbol_kind::S_BUILTIN: // "builtin"
      case symbol_kind::S_CALL: // "call"
      case symbol_kind::S_CALL_BUILTIN: // "call_builtin"
      case symbol_kind::S_INT_TYPE: // "integer type"
      case symbol_kind::S_BUILTIN_TYPE: // "builtin type"
      case symbol_kind::S_SUBPROG: // "subprog"
      case symbol_kind::S_SIZED_TYPE: // "sized type"
      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_PATH: // "path"
      case symbol_kind::S_CPREPROC: // "preprocessor directive"
      case symbol_kind::S_STRUCT_DEFN: // "struct definition"
      case symbol_kind::S_ENUM: // "enum"
      case symbol_kind::S_STRING: // "string"
      case symbol_kind::S_MAP: // "map"
      case symbol_kind::S_VAR: // "variable"
      case symbol_kind::S_PARAM: // "positional parameter"
      case symbol_kind::S_STACK_MODE: // "stack_mode"
      case symbol_kind::S_CONFIG: // "config"
      case symbol_kind::S_UNROLL: // "unroll"
      case symbol_kind::S_WHILE: // "while"
      case symbol_kind::S_FOR: // "for"
      case symbol_kind::S_RETURN: // "return"
      case symbol_kind::S_IF: // "if"
      case symbol_kind::S_ELSE: // "else"
      case symbol_kind::S_CONTINUE: // "continue"
      case symbol_kind::S_BREAK: // "break"
      case symbol_kind::S_SIZEOF: // "sizeof"
      case symbol_kind::S_OFFSETOF: // "offsetof"
      case symbol_kind::S_LET: // "let"
      case symbol_kind::S_c_definitions: // c_definitions
      case symbol_kind::S_attach_point_def: // attach_point_def
      case symbol_kind::S_keyword: // keyword
      case symbol_kind::S_ident: // ident
      case symbol_kind::S_external_name: // external_name
        value.move< std::string > (that.value);
        break;

      case symbol_kind::S_struct_field: // struct_field
        value.move< std::vector<std::string> > (that.value);
        break;

      default:
        break;
    }

    location = that.location;
    // that is emptied.
    that.state = empty_state;
    return *this;
  }
#endif

  template <typename Base>
  void
  Parser::yy_destroy_ (const char* yymsg, basic_symbol<Base>& yysym) const
  {
    if (yymsg)
      YY_SYMBOL_PRINT (yymsg, yysym);
  }

#if YYDEBUG
  template <typename Base>
  void
  Parser::yy_print_ (std::ostream& yyo, const basic_symbol<Base>& yysym) const
  {
    std::ostream& yyoutput = yyo;
    YY_USE (yyoutput);
    if (yysym.empty ())
      yyo << "empty symbol";
    else
      {
        symbol_kind_type yykind = yysym.kind ();
        yyo << (yykind < YYNTOKENS ? "token" : "nterm")
            << ' ' << yysym.name () << " ("
            << yysym.location << ": ";
        YY_USE (yykind);
        yyo << ')';
      }
  }
#endif

  void
  Parser::yypush_ (const char* m, YY_MOVE_REF (stack_symbol_type) sym)
  {
    if (m)
      YY_SYMBOL_PRINT (m, sym);
    yystack_.push (YY_MOVE (sym));
  }

  void
  Parser::yypush_ (const char* m, state_type s, YY_MOVE_REF (symbol_type) sym)
  {
#if 201103L <= YY_CPLUSPLUS
    yypush_ (m, stack_symbol_type (s, std::move (sym)));
#else
    stack_symbol_type ss (s, sym);
    yypush_ (m, ss);
#endif
  }

  void
  Parser::yypop_ (int n) YY_NOEXCEPT
  {
    yystack_.pop (n);
  }

#if YYDEBUG
  std::ostream&
  Parser::debug_stream () const
  {
    return *yycdebug_;
  }

  void
  Parser::set_debug_stream (std::ostream& o)
  {
    yycdebug_ = &o;
  }


  Parser::debug_level_type
  Parser::debug_level () const
  {
    return yydebug_;
  }

  void
  Parser::set_debug_level (debug_level_type l)
  {
    yydebug_ = l;
  }
#endif // YYDEBUG

  Parser::state_type
  Parser::yy_lr_goto_state_ (state_type yystate, int yysym)
  {
    int yyr = yypgoto_[yysym - YYNTOKENS] + yystate;
    if (0 <= yyr && yyr <= yylast_ && yycheck_[yyr] == yystate)
      return yytable_[yyr];
    else
      return yydefgoto_[yysym - YYNTOKENS];
  }

  bool
  Parser::yy_pact_value_is_default_ (int yyvalue) YY_NOEXCEPT
  {
    return yyvalue == yypact_ninf_;
  }

  bool
  Parser::yy_table_value_is_error_ (int yyvalue) YY_NOEXCEPT
  {
    return yyvalue == yytable_ninf_;
  }

  int
  Parser::operator() ()
  {
    return parse ();
  }

  int
  Parser::parse ()
  {
    int yyn;
    /// Length of the RHS of the rule being reduced.
    int yylen = 0;

    // Error handling.
    int yynerrs_ = 0;
    int yyerrstatus_ = 0;

    /// The lookahead symbol.
    symbol_type yyla;

    /// The locations where the error started and ended.
    stack_symbol_type yyerror_range[3];

    /// The return value of parse ().
    int yyresult;

#if YY_EXCEPTIONS
    try
#endif // YY_EXCEPTIONS
      {
    YYCDEBUG << "Starting parse\n";


    /* Initialize the stack.  The initial state will be set in
       yynewstate, since the latter expects the semantical and the
       location values to have been already stored, initialize these
       stacks with a primary value.  */
    yystack_.clear ();
    yypush_ (YY_NULLPTR, 0, YY_MOVE (yyla));

  /*-----------------------------------------------.
  | yynewstate -- push a new symbol on the stack.  |
  `-----------------------------------------------*/
  yynewstate:
    YYCDEBUG << "Entering state " << int (yystack_[0].state) << '\n';
    YY_STACK_PRINT ();

    // Accept?
    if (yystack_[0].state == yyfinal_)
      YYACCEPT;

    goto yybackup;


  /*-----------.
  | yybackup.  |
  `-----------*/
  yybackup:
    // Try to take a decision without lookahead.
    yyn = yypact_[+yystack_[0].state];
    if (yy_pact_value_is_default_ (yyn))
      goto yydefault;

    // Read a lookahead token.
    if (yyla.empty ())
      {
        YYCDEBUG << "Reading a token\n";
#if YY_EXCEPTIONS
        try
#endif // YY_EXCEPTIONS
          {
            symbol_type yylookahead (yylex (driver, yyscanner));
            yyla.move (yylookahead);
          }
#if YY_EXCEPTIONS
        catch (const syntax_error& yyexc)
          {
            YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
            error (yyexc);
            goto yyerrlab1;
          }
#endif // YY_EXCEPTIONS
      }
    YY_SYMBOL_PRINT ("Next token is", yyla);

    if (yyla.kind () == symbol_kind::S_YYerror)
    {
      // The scanner already issued an error message, process directly
      // to error recovery.  But do not keep the error token as
      // lookahead, it is too special and may lead us to an endless
      // loop in error recovery. */
      yyla.kind_ = symbol_kind::S_YYUNDEF;
      goto yyerrlab1;
    }

    /* If the proper action on seeing token YYLA.TYPE is to reduce or
       to detect an error, take that action.  */
    yyn += yyla.kind ();
    if (yyn < 0 || yylast_ < yyn || yycheck_[yyn] != yyla.kind ())
      {
        goto yydefault;
      }

    // Reduce or error.
    yyn = yytable_[yyn];
    if (yyn <= 0)
      {
        if (yy_table_value_is_error_ (yyn))
          goto yyerrlab;
        yyn = -yyn;
        goto yyreduce;
      }

    // Count tokens shifted since error; after three, turn off error status.
    if (yyerrstatus_)
      --yyerrstatus_;

    // Shift the lookahead token.
    yypush_ ("Shifting", state_type (yyn), YY_MOVE (yyla));
    goto yynewstate;


  /*-----------------------------------------------------------.
  | yydefault -- do the default action for the current state.  |
  `-----------------------------------------------------------*/
  yydefault:
    yyn = yydefact_[+yystack_[0].state];
    if (yyn == 0)
      goto yyerrlab;
    goto yyreduce;


  /*-----------------------------.
  | yyreduce -- do a reduction.  |
  `-----------------------------*/
  yyreduce:
    yylen = yyr2_[yyn];
    {
      stack_symbol_type yylhs;
      yylhs.state = yy_lr_goto_state_ (yystack_[yylen].state, yyr1_[yyn]);
      /* Variants are always initialized to an empty instance of the
         correct type. The default '$$ = $1' action is NOT applied
         when using variants.  */
      switch (yyr1_[yyn])
    {
      case symbol_kind::S_type: // type
      case symbol_kind::S_int_type: // int_type
      case symbol_kind::S_pointer_type: // pointer_type
      case symbol_kind::S_struct_type: // struct_type
        yylhs.value.emplace< SizedType > ();
        break;

      case symbol_kind::S_attach_point: // attach_point
        yylhs.value.emplace< ast::AttachPoint * > ();
        break;

      case symbol_kind::S_attach_points: // attach_points
        yylhs.value.emplace< ast::AttachPointList > ();
        break;

      case symbol_kind::S_call: // call
        yylhs.value.emplace< ast::Call * > ();
        break;

      case symbol_kind::S_config: // config
        yylhs.value.emplace< ast::Config * > ();
        break;

      case symbol_kind::S_primary_expr: // primary_expr
      case symbol_kind::S_postfix_expr: // postfix_expr
      case symbol_kind::S_tuple_access_expr: // tuple_access_expr
      case symbol_kind::S_unary_expr: // unary_expr
      case symbol_kind::S_expr: // expr
      case symbol_kind::S_conditional_expr: // conditional_expr
      case symbol_kind::S_logical_or_expr: // logical_or_expr
      case symbol_kind::S_logical_and_expr: // logical_and_expr
      case symbol_kind::S_or_expr: // or_expr
      case symbol_kind::S_xor_expr: // xor_expr
      case symbol_kind::S_and_expr: // and_expr
      case symbol_kind::S_equality_expr: // equality_expr
      case symbol_kind::S_relational_expr: // relational_expr
      case symbol_kind::S_shift_expr: // shift_expr
      case symbol_kind::S_muli_expr: // muli_expr
      case symbol_kind::S_addi_expr: // addi_expr
      case symbol_kind::S_cast_expr: // cast_expr
      case symbol_kind::S_map_or_var: // map_or_var
        yylhs.value.emplace< ast::Expression * > ();
        break;

      case symbol_kind::S_vargs: // vargs
        yylhs.value.emplace< ast::ExpressionList > ();
        break;

      case symbol_kind::S_int: // int
        yylhs.value.emplace< ast::Integer * > ();
        break;

      case symbol_kind::S_map: // map
        yylhs.value.emplace< ast::Map * > ();
        break;

      case symbol_kind::S_offsetof_expr: // offsetof_expr
        yylhs.value.emplace< ast::Offsetof * > ();
        break;

      case symbol_kind::S_unary_op: // unary_op
      case symbol_kind::S_compound_op: // compound_op
        yylhs.value.emplace< ast::Operator > ();
        break;

      case symbol_kind::S_param: // param
        yylhs.value.emplace< ast::PositionalParameter * > ();
        break;

      case symbol_kind::S_pred: // pred
        yylhs.value.emplace< ast::Predicate * > ();
        break;

      case symbol_kind::S_probe: // probe
        yylhs.value.emplace< ast::Probe * > ();
        break;

      case symbol_kind::S_sizeof_expr: // sizeof_expr
        yylhs.value.emplace< ast::Sizeof * > ();
        break;

      case symbol_kind::S_config_assign_stmt: // config_assign_stmt
      case symbol_kind::S_block_stmt: // block_stmt
      case symbol_kind::S_expr_stmt: // expr_stmt
      case symbol_kind::S_jump_stmt: // jump_stmt
      case symbol_kind::S_loop_stmt: // loop_stmt
      case symbol_kind::S_for_stmt: // for_stmt
      case symbol_kind::S_if_stmt: // if_stmt
      case symbol_kind::S_assign_stmt: // assign_stmt
        yylhs.value.emplace< ast::Statement * > ();
        break;

      case symbol_kind::S_config_block: // config_block
      case symbol_kind::S_config_assign_stmt_list: // config_assign_stmt_list
      case symbol_kind::S_block: // block
      case symbol_kind::S_stmt_list: // stmt_list
      case symbol_kind::S_block_or_if: // block_or_if
        yylhs.value.emplace< ast::StatementList > ();
        break;

      case symbol_kind::S_subprog: // subprog
        yylhs.value.emplace< ast::Subprog * > ();
        break;

      case symbol_kind::S_subprog_arg: // subprog_arg
        yylhs.value.emplace< ast::SubprogArg * > ();
        break;

      case symbol_kind::S_subprog_args: // subprog_args
        yylhs.value.emplace< ast::SubprogArgList > ();
        break;

      case symbol_kind::S_var_decl_stmt: // var_decl_stmt
        yylhs.value.emplace< ast::VarDeclStatement * > ();
        break;

      case symbol_kind::S_var: // var
        yylhs.value.emplace< ast::Variable * > ();
        break;

      case symbol_kind::S_INT: // "integer"
        yylhs.value.emplace< int64_t > ();
        break;

      case symbol_kind::S_probes_and_subprogs: // probes_and_subprogs
        yylhs.value.emplace< std::pair<ast::ProbeList, ast::SubprogList> > ();
        break;

      case symbol_kind::S_BUILTIN: // "builtin"
      case symbol_kind::S_CALL: // "call"
      case symbol_kind::S_CALL_BUILTIN: // "call_builtin"
      case symbol_kind::S_INT_TYPE: // "integer type"
      case symbol_kind::S_BUILTIN_TYPE: // "builtin type"
      case symbol_kind::S_SUBPROG: // "subprog"
      case symbol_kind::S_SIZED_TYPE: // "sized type"
      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_PATH: // "path"
      case symbol_kind::S_CPREPROC: // "preprocessor directive"
      case symbol_kind::S_STRUCT_DEFN: // "struct definition"
      case symbol_kind::S_ENUM: // "enum"
      case symbol_kind::S_STRING: // "string"
      case symbol_kind::S_MAP: // "map"
      case symbol_kind::S_VAR: // "variable"
      case symbol_kind::S_PARAM: // "positional parameter"
      case symbol_kind::S_STACK_MODE: // "stack_mode"
      case symbol_kind::S_CONFIG: // "config"
      case symbol_kind::S_UNROLL: // "unroll"
      case symbol_kind::S_WHILE: // "while"
      case symbol_kind::S_FOR: // "for"
      case symbol_kind::S_RETURN: // "return"
      case symbol_kind::S_IF: // "if"
      case symbol_kind::S_ELSE: // "else"
      case symbol_kind::S_CONTINUE: // "continue"
      case symbol_kind::S_BREAK: // "break"
      case symbol_kind::S_SIZEOF: // "sizeof"
      case symbol_kind::S_OFFSETOF: // "offsetof"
      case symbol_kind::S_LET: // "let"
      case symbol_kind::S_c_definitions: // c_definitions
      case symbol_kind::S_attach_point_def: // attach_point_def
      case symbol_kind::S_keyword: // keyword
      case symbol_kind::S_ident: // ident
      case symbol_kind::S_external_name: // external_name
        yylhs.value.emplace< std::string > ();
        break;

      case symbol_kind::S_struct_field: // struct_field
        yylhs.value.emplace< std::vector<std::string> > ();
        break;

      default:
        break;
    }


      // Default location.
      {
        stack_type::slice range (yystack_, yylen);
        YYLLOC_DEFAULT (yylhs.location, range, yylen);
        yyerror_range[1].location = yylhs.location;
      }

      // Perform the reduction.
      YY_REDUCE_PRINT (yyn);
#if YY_EXCEPTIONS
      try
#endif // YY_EXCEPTIONS
        {
          switch (yyn)
            {
  case 2: // program: c_definitions config probes_and_subprogs "end of file"
#line 183 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                                             {
                    driver.ctx.root = driver.ctx.make_node<ast::Program>(yystack_[3].value.as < std::string > (), yystack_[2].value.as < ast::Config * > (), std::move(yystack_[1].value.as < std::pair<ast::ProbeList, ast::SubprogList> > ().second), std::move(yystack_[1].value.as < std::pair<ast::ProbeList, ast::SubprogList> > ().first), yylhs.location);
                }
#line 1390 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 3: // c_definitions: "preprocessor directive" c_definitions
#line 189 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                                 { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + "\n" + yystack_[0].value.as < std::string > (); }
#line 1396 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 4: // c_definitions: "struct" "struct definition" c_definitions
#line 190 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                                 { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + ";\n" + yystack_[0].value.as < std::string > (); }
#line 1402 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 5: // c_definitions: "struct" "enum" c_definitions
#line 191 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                                 { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + ";\n" + yystack_[0].value.as < std::string > (); }
#line 1408 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 6: // c_definitions: %empty
#line 192 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                                 { yylhs.value.as < std::string > () = std::string(); }
#line 1414 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 7: // type: int_type
#line 196 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                         { yylhs.value.as < SizedType > () = yystack_[0].value.as < SizedType > (); }
#line 1420 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 8: // type: "builtin type"
#line 197 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                             {
                    static std::unordered_map<std::string, SizedType> type_map = {
                        {"void", CreateVoid()},
                        {"min_t", CreateMin(true)},
                        {"max_t", CreateMax(true)},
                        {"sum_t", CreateSum(true)},
                        {"count_t", CreateCount(true)},
                        {"avg_t", CreateAvg(true)},
                        {"stats_t", CreateStats(true)},
                        {"umin_t", CreateMin(false)},
                        {"umax_t", CreateMax(false)},
                        {"usum_t", CreateSum(false)},
                        {"ucount_t", CreateCount(false)},
                        {"uavg_t", CreateAvg(false)},
                        {"ustats_t", CreateStats(false)},
                        {"timestamp", CreateTimestamp()},
                        {"macaddr_t", CreateMacAddress()},
                        {"cgroup_path_t", CreateCgroupPath()},
                        {"strerror_t", CreateStrerror()},
                    };
                    yylhs.value.as < SizedType > () = type_map[yystack_[0].value.as < std::string > ()];
                }
#line 1447 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 9: // type: "sized type"
#line 219 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                           {
                    if (yystack_[0].value.as < std::string > () == "string") {
                        yylhs.value.as < SizedType > () = CreateString(0);
                    } else if (yystack_[0].value.as < std::string > () == "inet") {
                        yylhs.value.as < SizedType > () = CreateInet(0);
                    } else if (yystack_[0].value.as < std::string > () == "buffer") {
                        yylhs.value.as < SizedType > () = CreateBuffer(0);
                    }
                }
#line 1461 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 10: // type: "sized type" "[" "integer" "]"
#line 228 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                       {
                    if (yystack_[3].value.as < std::string > () == "string") {
                        yylhs.value.as < SizedType > () = CreateString(yystack_[1].value.as < int64_t > ());
                    } else if (yystack_[3].value.as < std::string > () == "inet") {
                        yylhs.value.as < SizedType > () = CreateInet(yystack_[1].value.as < int64_t > ());
                    } else if (yystack_[3].value.as < std::string > () == "buffer") {
                        yylhs.value.as < SizedType > () = CreateBuffer(yystack_[1].value.as < int64_t > ());
                    }
                }
#line 1475 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 11: // type: int_type "[" "integer" "]"
#line 237 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                     {
                  yylhs.value.as < SizedType > () = CreateArray(yystack_[1].value.as < int64_t > (), yystack_[3].value.as < SizedType > ());
                }
#line 1483 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 12: // type: struct_type "[" "integer" "]"
#line 240 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                        {
                  yylhs.value.as < SizedType > () = CreateArray(yystack_[1].value.as < int64_t > (), yystack_[3].value.as < SizedType > ());
                }
#line 1491 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 13: // type: int_type "[" "]"
#line 243 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                 {
                  yylhs.value.as < SizedType > () = CreateArray(0, yystack_[2].value.as < SizedType > ());
                }
#line 1499 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 14: // type: pointer_type
#line 246 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                             { yylhs.value.as < SizedType > () = yystack_[0].value.as < SizedType > (); }
#line 1505 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 15: // type: struct_type
#line 247 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                            { yylhs.value.as < SizedType > () = yystack_[0].value.as < SizedType > (); }
#line 1511 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 16: // int_type: "integer type"
#line 251 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                         {
                    static std::unordered_map<std::string, SizedType> type_map = {
                        {"bool", CreateBool()},
                        {"uint8", CreateUInt(8)},
                        {"uint16", CreateUInt(16)},
                        {"uint32", CreateUInt(32)},
                        {"uint64", CreateUInt(64)},
                        {"int8", CreateInt(8)},
                        {"int16", CreateInt(16)},
                        {"int32", CreateInt(32)},
                        {"int64", CreateInt(64)},
                    };
                    yylhs.value.as < SizedType > () = type_map[yystack_[0].value.as < std::string > ()];
                }
#line 1530 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 17: // pointer_type: type "*"
#line 268 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                         { yylhs.value.as < SizedType > () = CreatePointer(yystack_[1].value.as < SizedType > ()); }
#line 1536 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 18: // struct_type: "struct" "identifier"
#line 271 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                             { yylhs.value.as < SizedType > () = ast::ident_to_sized_type(yystack_[0].value.as < std::string > ()); }
#line 1542 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 19: // config: "config" "=" config_block
#line 275 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                               { yylhs.value.as < ast::Config * > () = driver.ctx.make_node<ast::Config>(std::move(yystack_[0].value.as < ast::StatementList > ()), yylhs.location); }
#line 1548 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 20: // config: %empty
#line 276 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                               { yylhs.value.as < ast::Config * > () = nullptr; }
#line 1554 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 21: // config_block: "{" config_assign_stmt_list "}"
#line 282 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                                                   { yylhs.value.as < ast::StatementList > () = std::move(yystack_[1].value.as < ast::StatementList > ()); }
#line 1560 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 22: // config_block: "{" config_assign_stmt_list config_assign_stmt "}"
#line 283 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                                                   { yylhs.value.as < ast::StatementList > () = std::move(yystack_[2].value.as < ast::StatementList > ()); yylhs.value.as < ast::StatementList > ().push_back(yystack_[1].value.as < ast::Statement * > ()); }
#line 1566 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 23: // config_assign_stmt_list: config_assign_stmt_list config_assign_stmt ";"
#line 287 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                                               { yylhs.value.as < ast::StatementList > () = std::move(yystack_[2].value.as < ast::StatementList > ()); yylhs.value.as < ast::StatementList > ().push_back(yystack_[1].value.as < ast::Statement * > ()); }
#line 1572 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 24: // config_assign_stmt_list: %empty
#line 288 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                                               { yylhs.value.as < ast::StatementList > () = ast::StatementList{}; }
#line 1578 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 25: // config_assign_stmt: "identifier" "=" expr
#line 292 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                    { yylhs.value.as < ast::Statement * > () = driver.ctx.make_node<ast::AssignConfigVarStatement>(yystack_[2].value.as < std::string > (), yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1584 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 26: // subprog: "subprog" "identifier" "(" subprog_args ")" ":" type block
#line 296 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                                                  {
                    yylhs.value.as < ast::Subprog * > () = driver.ctx.make_node<ast::Subprog>(yystack_[6].value.as < std::string > (), yystack_[1].value.as < SizedType > (), std::move(yystack_[4].value.as < ast::SubprogArgList > ()), std::move(yystack_[0].value.as < ast::StatementList > ()), yylhs.location);
                }
#line 1592 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 27: // subprog: "subprog" "identifier" "(" ")" ":" type block
#line 299 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                                     {
                    yylhs.value.as < ast::Subprog * > () = driver.ctx.make_node<ast::Subprog>(yystack_[5].value.as < std::string > (), yystack_[1].value.as < SizedType > (), ast::SubprogArgList(), std::move(yystack_[0].value.as < ast::StatementList > ()), yylhs.location);
                }
#line 1600 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 28: // subprog_args: subprog_args "," subprog_arg
#line 305 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                             { yylhs.value.as < ast::SubprogArgList > () = std::move(yystack_[2].value.as < ast::SubprogArgList > ()); yylhs.value.as < ast::SubprogArgList > ().push_back(yystack_[0].value.as < ast::SubprogArg * > ()); }
#line 1606 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 29: // subprog_args: subprog_arg
#line 306 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                             { yylhs.value.as < ast::SubprogArgList > () = ast::SubprogArgList{yystack_[0].value.as < ast::SubprogArg * > ()}; }
#line 1612 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 30: // subprog_arg: "variable" ":" type
#line 310 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                             { yylhs.value.as < ast::SubprogArg * > () = driver.ctx.make_node<ast::SubprogArg>(yystack_[2].value.as < std::string > (), yystack_[0].value.as < SizedType > (), yylhs.location); }
#line 1618 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 31: // probes_and_subprogs: probes_and_subprogs probe
#line 314 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                            { yylhs.value.as < std::pair<ast::ProbeList, ast::SubprogList> > () = std::move(yystack_[1].value.as < std::pair<ast::ProbeList, ast::SubprogList> > ()); yylhs.value.as < std::pair<ast::ProbeList, ast::SubprogList> > ().first.push_back(yystack_[0].value.as < ast::Probe * > ()); }
#line 1624 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 32: // probes_and_subprogs: probes_and_subprogs subprog
#line 315 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                            { yylhs.value.as < std::pair<ast::ProbeList, ast::SubprogList> > () = std::move(yystack_[1].value.as < std::pair<ast::ProbeList, ast::SubprogList> > ()); yylhs.value.as < std::pair<ast::ProbeList, ast::SubprogList> > ().second.push_back(yystack_[0].value.as < ast::Subprog * > ()); }
#line 1630 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 33: // probes_and_subprogs: probe
#line 316 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                             { yylhs.value.as < std::pair<ast::ProbeList, ast::SubprogList> > () = { ast::ProbeList{yystack_[0].value.as < ast::Probe * > ()}, ast::SubprogList{}}; }
#line 1636 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 34: // probes_and_subprogs: subprog
#line 317 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                             { yylhs.value.as < std::pair<ast::ProbeList, ast::SubprogList> > () = { ast::ProbeList{}, ast::SubprogList{yystack_[0].value.as < ast::Subprog * > ()}}; }
#line 1642 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 35: // probe: attach_points pred block
#line 322 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                {
                  if (!driver.listing_)
                    yylhs.value.as < ast::Probe * > () = driver.ctx.make_node<ast::Probe>(std::move(yystack_[2].value.as < ast::AttachPointList > ()), yystack_[1].value.as < ast::Predicate * > (), driver.ctx.make_node<ast::Block>(std::move(yystack_[0].value.as < ast::StatementList > ()), yystack_[0].location), yylhs.location);
                  else
                  {
                    error(yylhs.location, "unexpected listing query format");
                    YYERROR;
                  }
                }
#line 1656 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 36: // probe: attach_points "end of file"
#line 332 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                {
                  if (driver.listing_)
                    yylhs.value.as < ast::Probe * > () = driver.ctx.make_node<ast::Probe>(std::move(yystack_[1].value.as < ast::AttachPointList > ()), nullptr, driver.ctx.make_node<ast::Block>(ast::StatementList(), yylhs.location), yylhs.location);
                  else
                  {
                    error(yylhs.location, "unexpected end of file, expected {");
                    YYERROR;
                  }
                }
#line 1670 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 37: // attach_points: attach_points "," attach_point
#line 344 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                               { yylhs.value.as < ast::AttachPointList > () = std::move(yystack_[2].value.as < ast::AttachPointList > ()); yylhs.value.as < ast::AttachPointList > ().push_back(yystack_[0].value.as < ast::AttachPoint * > ()); }
#line 1676 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 38: // attach_points: attach_point
#line 345 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                               { yylhs.value.as < ast::AttachPointList > () = ast::AttachPointList{yystack_[0].value.as < ast::AttachPoint * > ()}; }
#line 1682 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 39: // attach_point: attach_point_def
#line 349 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                                { yylhs.value.as < ast::AttachPoint * > () = driver.ctx.make_node<ast::AttachPoint>(yystack_[0].value.as < std::string > (), false, yylhs.location); }
#line 1688 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 40: // attach_point_def: attach_point_def ident
#line 353 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + yystack_[0].value.as < std::string > (); }
#line 1694 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 41: // attach_point_def: attach_point_def "string"
#line 357 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + "\"" + std::regex_replace(yystack_[0].value.as < std::string > (), std::regex("\""), "\\\"") + "\""; }
#line 1700 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 42: // attach_point_def: attach_point_def "path"
#line 358 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + yystack_[0].value.as < std::string > (); }
#line 1706 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 43: // attach_point_def: attach_point_def "integer"
#line 359 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + std::to_string(yystack_[0].value.as < int64_t > ()); }
#line 1712 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 44: // attach_point_def: attach_point_def ":"
#line 360 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + ":"; }
#line 1718 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 45: // attach_point_def: attach_point_def "."
#line 361 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + "."; }
#line 1724 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 46: // attach_point_def: attach_point_def "+"
#line 362 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + "+"; }
#line 1730 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 47: // attach_point_def: attach_point_def "*"
#line 363 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + "*"; }
#line 1736 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 48: // attach_point_def: attach_point_def "["
#line 364 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + "["; }
#line 1742 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 49: // attach_point_def: attach_point_def "]"
#line 365 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + "]"; }
#line 1748 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 50: // attach_point_def: attach_point_def param
#line 367 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                {
                  if (yystack_[0].value.as < ast::PositionalParameter * > ()->ptype != PositionalParameterType::positional)
                  {
                    error(yylhs.location, "Not a positional parameter");
                    YYERROR;
                  }
                  // "Un-parse" the positional parameter back into text so
                  // we can give it to the AttachPointParser. This is kind of
                  // a hack but there doesn't look to be any other way.
                  yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + "$" + std::to_string(yystack_[0].value.as < ast::PositionalParameter * > ()->n);
                }
#line 1764 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 51: // attach_point_def: %empty
#line 378 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                          { yylhs.value.as < std::string > () = ""; }
#line 1770 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 52: // pred: "/" expr "end predicate"
#line 382 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                 { yylhs.value.as < ast::Predicate * > () = driver.ctx.make_node<ast::Predicate>(yystack_[1].value.as < ast::Expression * > (), yylhs.location); }
#line 1776 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 53: // pred: %empty
#line 383 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                  { yylhs.value.as < ast::Predicate * > () = nullptr; }
#line 1782 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 54: // param: "positional parameter"
#line 388 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                      {
                        try {
                          long n = std::stol(yystack_[0].value.as < std::string > ().substr(1, yystack_[0].value.as < std::string > ().size()-1));
                          if (n == 0) throw std::exception();
                          yylhs.value.as < ast::PositionalParameter * > () = driver.ctx.make_node<ast::PositionalParameter>(PositionalParameterType::positional, n, yylhs.location);
                        } catch (std::exception const& e) {
                          error(yystack_[0].location, "param " + yystack_[0].value.as < std::string > () + " is out of integer range [1, " +
                                std::to_string(std::numeric_limits<long>::max()) + "]");
                          YYERROR;
                        }
                      }
#line 1798 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 55: // param: "$#"
#line 399 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                           { yylhs.value.as < ast::PositionalParameter * > () = driver.ctx.make_node<ast::PositionalParameter>(PositionalParameterType::count, 0, yylhs.location); }
#line 1804 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 56: // block: "{" stmt_list "}"
#line 406 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                                    { yylhs.value.as < ast::StatementList > () = std::move(yystack_[1].value.as < ast::StatementList > ()); }
#line 1810 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 57: // block: "{" stmt_list expr_stmt "}"
#line 407 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                                    { yylhs.value.as < ast::StatementList > () = std::move(yystack_[2].value.as < ast::StatementList > ()); yylhs.value.as < ast::StatementList > ().push_back(yystack_[1].value.as < ast::Statement * > ()); }
#line 1816 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 58: // stmt_list: stmt_list expr_stmt ";"
#line 411 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                            { yylhs.value.as < ast::StatementList > () = std::move(yystack_[2].value.as < ast::StatementList > ()); yylhs.value.as < ast::StatementList > ().push_back(yystack_[1].value.as < ast::Statement * > ()); }
#line 1822 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 59: // stmt_list: stmt_list block_stmt
#line 412 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                            { yylhs.value.as < ast::StatementList > () = std::move(yystack_[1].value.as < ast::StatementList > ()); yylhs.value.as < ast::StatementList > ().push_back(yystack_[0].value.as < ast::Statement * > ()); }
#line 1828 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 60: // stmt_list: stmt_list var_decl_stmt ";"
#line 413 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                            { yylhs.value.as < ast::StatementList > () = std::move(yystack_[2].value.as < ast::StatementList > ()); yylhs.value.as < ast::StatementList > ().push_back(yystack_[1].value.as < ast::VarDeclStatement * > ()); }
#line 1834 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 61: // stmt_list: %empty
#line 414 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                            { yylhs.value.as < ast::StatementList > () = ast::StatementList{}; }
#line 1840 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 62: // block_stmt: loop_stmt
#line 418 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                             { yylhs.value.as < ast::Statement * > () = yystack_[0].value.as < ast::Statement * > (); }
#line 1846 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 63: // block_stmt: if_stmt
#line 419 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                             { yylhs.value.as < ast::Statement * > () = yystack_[0].value.as < ast::Statement * > (); }
#line 1852 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 64: // block_stmt: for_stmt
#line 420 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                             { yylhs.value.as < ast::Statement * > () = yystack_[0].value.as < ast::Statement * > (); }
#line 1858 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 65: // expr_stmt: expr
#line 424 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                   { yylhs.value.as < ast::Statement * > () = driver.ctx.make_node<ast::ExprStatement>(yystack_[0].value.as < ast::Expression * > (), yystack_[0].location); }
#line 1864 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 66: // expr_stmt: jump_stmt
#line 425 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                   { yylhs.value.as < ast::Statement * > () = yystack_[0].value.as < ast::Statement * > (); }
#line 1870 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 67: // expr_stmt: assign_stmt
#line 430 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                   { yylhs.value.as < ast::Statement * > () = yystack_[0].value.as < ast::Statement * > (); }
#line 1876 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 68: // jump_stmt: "break"
#line 434 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                            { yylhs.value.as < ast::Statement * > () = driver.ctx.make_node<ast::Jump>(ast::JumpType::BREAK, yylhs.location); }
#line 1882 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 69: // jump_stmt: "continue"
#line 435 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                            { yylhs.value.as < ast::Statement * > () = driver.ctx.make_node<ast::Jump>(ast::JumpType::CONTINUE, yylhs.location); }
#line 1888 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 70: // jump_stmt: "return"
#line 436 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                            { yylhs.value.as < ast::Statement * > () = driver.ctx.make_node<ast::Jump>(ast::JumpType::RETURN, yylhs.location); }
#line 1894 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 71: // jump_stmt: "return" expr
#line 437 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                            { yylhs.value.as < ast::Statement * > () = driver.ctx.make_node<ast::Jump>(ast::JumpType::RETURN, yystack_[0].value.as < ast::Expression * > (), yylhs.location); }
#line 1900 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 72: // loop_stmt: "unroll" "(" int ")" block
#line 441 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                                     { yylhs.value.as < ast::Statement * > () = driver.ctx.make_node<ast::Unroll>(yystack_[2].value.as < ast::Integer * > (), driver.ctx.make_node<ast::Block>(std::move(yystack_[0].value.as < ast::StatementList > ()), yystack_[0].location), yystack_[4].location + yystack_[1].location); }
#line 1906 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 73: // loop_stmt: "unroll" "(" param ")" block
#line 442 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                                     { yylhs.value.as < ast::Statement * > () = driver.ctx.make_node<ast::Unroll>(yystack_[2].value.as < ast::PositionalParameter * > (), driver.ctx.make_node<ast::Block>(std::move(yystack_[0].value.as < ast::StatementList > ()), yystack_[0].location), yystack_[4].location + yystack_[1].location); }
#line 1912 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 74: // loop_stmt: "while" "(" expr ")" block
#line 443 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                                     { yylhs.value.as < ast::Statement * > () = driver.ctx.make_node<ast::While>(yystack_[2].value.as < ast::Expression * > (), driver.ctx.make_node<ast::Block>(std::move(yystack_[0].value.as < ast::StatementList > ()), yystack_[0].location), yystack_[4].location); }
#line 1918 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 75: // for_stmt: "for" "(" var ":" expr ")" block
#line 447 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                                     { yylhs.value.as < ast::Statement * > () = driver.ctx.make_node<ast::For>(yystack_[4].value.as < ast::Variable * > (), yystack_[2].value.as < ast::Expression * > (), std::move(yystack_[0].value.as < ast::StatementList > ()), yystack_[6].location); }
#line 1924 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 76: // if_stmt: "if" "(" expr ")" block
#line 451 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                                       { yylhs.value.as < ast::Statement * > () = driver.ctx.make_node<ast::If>(yystack_[2].value.as < ast::Expression * > (), driver.ctx.make_node<ast::Block>(std::move(yystack_[0].value.as < ast::StatementList > ()), yystack_[0].location), driver.ctx.make_node<ast::Block>(ast::StatementList(), yystack_[4].location), yylhs.location); }
#line 1930 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 77: // if_stmt: "if" "(" expr ")" block "else" block_or_if
#line 452 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                                       { yylhs.value.as < ast::Statement * > () = driver.ctx.make_node<ast::If>(yystack_[4].value.as < ast::Expression * > (), driver.ctx.make_node<ast::Block>(std::move(yystack_[2].value.as < ast::StatementList > ()), yystack_[2].location), driver.ctx.make_node<ast::Block>(std::move(yystack_[0].value.as < ast::StatementList > ()), yystack_[0].location), yylhs.location); }
#line 1936 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 78: // block_or_if: block
#line 456 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                             { yylhs.value.as < ast::StatementList > () = std::move(yystack_[0].value.as < ast::StatementList > ()); }
#line 1942 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 79: // block_or_if: if_stmt
#line 457 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                             { yylhs.value.as < ast::StatementList > () = ast::StatementList{yystack_[0].value.as < ast::Statement * > ()}; }
#line 1948 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 80: // assign_stmt: tuple_access_expr "=" expr
#line 462 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                {
                  error(yystack_[2].location + yystack_[0].location, "Tuples are immutable once created. Consider creating a new tuple and assigning it instead.");
                  YYERROR;
                }
#line 1957 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 81: // assign_stmt: map "=" expr
#line 466 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                          { yylhs.value.as < ast::Statement * > () = driver.ctx.make_node<ast::AssignMapStatement>(yystack_[2].value.as < ast::Map * > (), yystack_[0].value.as < ast::Expression * > (), yylhs.location); }
#line 1963 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 82: // assign_stmt: var_decl_stmt "=" expr
#line 467 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                          { yylhs.value.as < ast::Statement * > () = driver.ctx.make_node<ast::AssignVarStatement>(yystack_[2].value.as < ast::VarDeclStatement * > (), yystack_[0].value.as < ast::Expression * > (), yylhs.location); }
#line 1969 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 83: // assign_stmt: var "=" expr
#line 468 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                          { yylhs.value.as < ast::Statement * > () = driver.ctx.make_node<ast::AssignVarStatement>(yystack_[2].value.as < ast::Variable * > (), yystack_[0].value.as < ast::Expression * > (), yylhs.location); }
#line 1975 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 84: // assign_stmt: map compound_op expr
#line 470 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                {
                  auto b = driver.ctx.make_node<ast::Binop>(yystack_[2].value.as < ast::Map * > (), yystack_[1].value.as < ast::Operator > (), yystack_[0].value.as < ast::Expression * > (), yystack_[1].location);
                  yylhs.value.as < ast::Statement * > () = driver.ctx.make_node<ast::AssignMapStatement>(yystack_[2].value.as < ast::Map * > (), b, yylhs.location);
                }
#line 1984 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 85: // assign_stmt: var compound_op expr
#line 475 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                {
                  auto b = driver.ctx.make_node<ast::Binop>(yystack_[2].value.as < ast::Variable * > (), yystack_[1].value.as < ast::Operator > (), yystack_[0].value.as < ast::Expression * > (), yystack_[1].location);
                  yylhs.value.as < ast::Statement * > () = driver.ctx.make_node<ast::AssignVarStatement>(yystack_[2].value.as < ast::Variable * > (), b, yylhs.location);
                }
#line 1993 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 86: // var_decl_stmt: "let" var
#line 482 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                         {  yylhs.value.as < ast::VarDeclStatement * > () = driver.ctx.make_node<ast::VarDeclStatement>(yystack_[0].value.as < ast::Variable * > (), yylhs.location); }
#line 1999 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 87: // var_decl_stmt: "let" var ":" type
#line 483 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                    {  yylhs.value.as < ast::VarDeclStatement * > () = driver.ctx.make_node<ast::VarDeclStatement>(yystack_[2].value.as < ast::Variable * > (), yystack_[0].value.as < SizedType > (), yylhs.location); }
#line 2005 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 88: // primary_expr: "identifier"
#line 487 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                   { yylhs.value.as < ast::Expression * > () = driver.ctx.make_node<ast::Identifier>(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 2011 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 89: // primary_expr: int
#line 488 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                   { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Integer * > (); }
#line 2017 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 90: // primary_expr: "string"
#line 489 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                   { yylhs.value.as < ast::Expression * > () = driver.ctx.make_node<ast::String>(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 2023 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 91: // primary_expr: "stack_mode"
#line 490 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                   { yylhs.value.as < ast::Expression * > () = driver.ctx.make_node<ast::StackMode>(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 2029 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 92: // primary_expr: "builtin"
#line 491 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                   { yylhs.value.as < ast::Expression * > () = driver.ctx.make_node<ast::Builtin>(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 2035 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 93: // primary_expr: "call_builtin"
#line 492 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                   { yylhs.value.as < ast::Expression * > () = driver.ctx.make_node<ast::Builtin>(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 2041 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 94: // primary_expr: "(" expr ")"
#line 493 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                   { yylhs.value.as < ast::Expression * > () = yystack_[1].value.as < ast::Expression * > (); }
#line 2047 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 95: // primary_expr: param
#line 494 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                   { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::PositionalParameter * > (); }
#line 2053 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 96: // primary_expr: map_or_var
#line 495 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                   { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 2059 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 97: // primary_expr: "(" vargs "," expr ")"
#line 497 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                {
                  auto &args = yystack_[3].value.as < ast::ExpressionList > ();
                  args.push_back(yystack_[1].value.as < ast::Expression * > ());
                  yylhs.value.as < ast::Expression * > () = driver.ctx.make_node<ast::Tuple>(std::move(args), yylhs.location);
                }
#line 2069 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 98: // postfix_expr: primary_expr
#line 505 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                               { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 2075 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 99: // postfix_expr: postfix_expr "." external_name
#line 507 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                               { yylhs.value.as < ast::Expression * > () = driver.ctx.make_node<ast::FieldAccess>(yystack_[2].value.as < ast::Expression * > (), yystack_[0].value.as < std::string > (), yystack_[1].location); }
#line 2081 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 100: // postfix_expr: postfix_expr "->" external_name
#line 508 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                               { yylhs.value.as < ast::Expression * > () = driver.ctx.make_node<ast::FieldAccess>(driver.ctx.make_node<ast::Unop>(ast::Operator::MUL, yystack_[2].value.as < ast::Expression * > (), false, yystack_[1].location), yystack_[0].value.as < std::string > (), yylhs.location); }
#line 2087 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 101: // postfix_expr: tuple_access_expr
#line 510 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                               { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 2093 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 102: // postfix_expr: postfix_expr "[" expr "]"
#line 512 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                               { yylhs.value.as < ast::Expression * > () = driver.ctx.make_node<ast::ArrayAccess>(yystack_[3].value.as < ast::Expression * > (), yystack_[1].value.as < ast::Expression * > (), yystack_[2].location + yystack_[0].location); }
#line 2099 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 103: // postfix_expr: call
#line 513 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                               { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Call * > (); }
#line 2105 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 104: // postfix_expr: sizeof_expr
#line 514 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                               { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Sizeof * > (); }
#line 2111 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 105: // postfix_expr: offsetof_expr
#line 515 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                               { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Offsetof * > (); }
#line 2117 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 106: // postfix_expr: map_or_var "++"
#line 516 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                               { yylhs.value.as < ast::Expression * > () = driver.ctx.make_node<ast::Unop>(ast::Operator::INCREMENT, yystack_[1].value.as < ast::Expression * > (), true, yystack_[0].location); }
#line 2123 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 107: // postfix_expr: map_or_var "--"
#line 517 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                               { yylhs.value.as < ast::Expression * > () = driver.ctx.make_node<ast::Unop>(ast::Operator::DECREMENT, yystack_[1].value.as < ast::Expression * > (), true, yystack_[0].location); }
#line 2129 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 108: // postfix_expr: "++" ident
#line 519 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                               { error(yystack_[1].location, "The ++ operator must be applied to a map or variable"); YYERROR; }
#line 2135 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 109: // postfix_expr: "--" ident
#line 520 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                               { error(yystack_[1].location, "The -- operator must be applied to a map or variable"); YYERROR; }
#line 2141 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 110: // tuple_access_expr: postfix_expr "." "integer"
#line 525 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                          { yylhs.value.as < ast::Expression * > () = driver.ctx.make_node<ast::FieldAccess>(yystack_[2].value.as < ast::Expression * > (), yystack_[0].value.as < int64_t > (), yystack_[0].location); }
#line 2147 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 111: // unary_expr: unary_op cast_expr
#line 531 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                     { yylhs.value.as < ast::Expression * > () = driver.ctx.make_node<ast::Unop>(yystack_[1].value.as < ast::Operator > (), yystack_[0].value.as < ast::Expression * > (), false, yystack_[1].location); }
#line 2153 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 112: // unary_expr: postfix_expr
#line 532 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                     { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 2159 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 113: // unary_expr: "++" map_or_var
#line 533 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                     { yylhs.value.as < ast::Expression * > () = driver.ctx.make_node<ast::Unop>(ast::Operator::INCREMENT, yystack_[0].value.as < ast::Expression * > (), false, yystack_[1].location); }
#line 2165 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 114: // unary_expr: "--" map_or_var
#line 534 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                     { yylhs.value.as < ast::Expression * > () = driver.ctx.make_node<ast::Unop>(ast::Operator::DECREMENT, yystack_[0].value.as < ast::Expression * > (), false, yystack_[1].location); }
#line 2171 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 115: // unary_expr: ident "--"
#line 536 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                     { error(yystack_[1].location, "The -- operator must be applied to a map or variable"); YYERROR; }
#line 2177 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 116: // unary_expr: ident "++"
#line 537 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                     { error(yystack_[1].location, "The ++ operator must be applied to a map or variable"); YYERROR; }
#line 2183 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 117: // unary_op: "*"
#line 541 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                       { yylhs.value.as < ast::Operator > () = ast::Operator::MUL; }
#line 2189 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 118: // unary_op: "~"
#line 542 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                       { yylhs.value.as < ast::Operator > () = ast::Operator::BNOT; }
#line 2195 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 119: // unary_op: "!"
#line 543 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                       { yylhs.value.as < ast::Operator > () = ast::Operator::LNOT; }
#line 2201 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 120: // unary_op: "-"
#line 544 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                       { yylhs.value.as < ast::Operator > () = ast::Operator::MINUS; }
#line 2207 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 121: // expr: conditional_expr
#line 548 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                    { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 2213 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 122: // conditional_expr: logical_or_expr
#line 552 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                                                 { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 2219 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 123: // conditional_expr: logical_or_expr "?" expr ":" conditional_expr
#line 553 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                                                 { yylhs.value.as < ast::Expression * > () = driver.ctx.make_node<ast::Ternary>(yystack_[4].value.as < ast::Expression * > (), yystack_[2].value.as < ast::Expression * > (), yystack_[0].value.as < ast::Expression * > (), yylhs.location); }
#line 2225 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 124: // logical_or_expr: logical_and_expr
#line 558 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                                     { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 2231 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 125: // logical_or_expr: logical_or_expr "||" logical_and_expr
#line 559 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                                     { yylhs.value.as < ast::Expression * > () = driver.ctx.make_node<ast::Binop>(yystack_[2].value.as < ast::Expression * > (), ast::Operator::LOR, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 2237 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 126: // logical_and_expr: or_expr
#line 563 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                              { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 2243 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 127: // logical_and_expr: logical_and_expr "&&" or_expr
#line 564 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                              { yylhs.value.as < ast::Expression * > () = driver.ctx.make_node<ast::Binop>(yystack_[2].value.as < ast::Expression * > (), ast::Operator::LAND, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 2249 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 128: // or_expr: xor_expr
#line 568 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                     { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 2255 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 129: // or_expr: or_expr "|" xor_expr
#line 569 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                     { yylhs.value.as < ast::Expression * > () = driver.ctx.make_node<ast::Binop>(yystack_[2].value.as < ast::Expression * > (), ast::Operator::BOR, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 2261 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 130: // xor_expr: and_expr
#line 573 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                       { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 2267 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 131: // xor_expr: xor_expr "^" and_expr
#line 574 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                       { yylhs.value.as < ast::Expression * > () = driver.ctx.make_node<ast::Binop>(yystack_[2].value.as < ast::Expression * > (), ast::Operator::BXOR, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 2273 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 132: // and_expr: equality_expr
#line 579 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                            { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 2279 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 133: // and_expr: and_expr "&" equality_expr
#line 580 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                            { yylhs.value.as < ast::Expression * > () = driver.ctx.make_node<ast::Binop>(yystack_[2].value.as < ast::Expression * > (), ast::Operator::BAND, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 2285 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 134: // equality_expr: relational_expr
#line 584 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                                 { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 2291 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 135: // equality_expr: equality_expr "==" relational_expr
#line 585 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                                 { yylhs.value.as < ast::Expression * > () = driver.ctx.make_node<ast::Binop>(yystack_[2].value.as < ast::Expression * > (), ast::Operator::EQ, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 2297 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 136: // equality_expr: equality_expr "!=" relational_expr
#line 586 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                                 { yylhs.value.as < ast::Expression * > () = driver.ctx.make_node<ast::Binop>(yystack_[2].value.as < ast::Expression * > (), ast::Operator::NE, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 2303 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 137: // relational_expr: shift_expr
#line 590 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                              { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 2309 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 138: // relational_expr: relational_expr "<=" shift_expr
#line 591 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                              { yylhs.value.as < ast::Expression * > () = driver.ctx.make_node<ast::Binop>(yystack_[2].value.as < ast::Expression * > (), ast::Operator::LE, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 2315 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 139: // relational_expr: relational_expr ">=" shift_expr
#line 592 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                              { yylhs.value.as < ast::Expression * > () = driver.ctx.make_node<ast::Binop>(yystack_[2].value.as < ast::Expression * > (), ast::Operator::GE, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 2321 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 140: // relational_expr: relational_expr "<" shift_expr
#line 593 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                              { yylhs.value.as < ast::Expression * > () = driver.ctx.make_node<ast::Binop>(yystack_[2].value.as < ast::Expression * > (), ast::Operator::LT, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 2327 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 141: // relational_expr: relational_expr ">" shift_expr
#line 594 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                              { yylhs.value.as < ast::Expression * > () = driver.ctx.make_node<ast::Binop>(yystack_[2].value.as < ast::Expression * > (), ast::Operator::GT, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 2333 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 142: // shift_expr: addi_expr
#line 598 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                           { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 2339 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 143: // shift_expr: shift_expr "<<" addi_expr
#line 599 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                           { yylhs.value.as < ast::Expression * > () = driver.ctx.make_node<ast::Binop>(yystack_[2].value.as < ast::Expression * > (), ast::Operator::LEFT, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 2345 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 144: // shift_expr: shift_expr ">>" addi_expr
#line 600 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                           { yylhs.value.as < ast::Expression * > () = driver.ctx.make_node<ast::Binop>(yystack_[2].value.as < ast::Expression * > (), ast::Operator::RIGHT, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 2351 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 145: // muli_expr: cast_expr
#line 604 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                           { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 2357 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 146: // muli_expr: muli_expr "*" cast_expr
#line 605 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                           { yylhs.value.as < ast::Expression * > () = driver.ctx.make_node<ast::Binop>(yystack_[2].value.as < ast::Expression * > (), ast::Operator::MUL, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 2363 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 147: // muli_expr: muli_expr "/" cast_expr
#line 606 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                           { yylhs.value.as < ast::Expression * > () = driver.ctx.make_node<ast::Binop>(yystack_[2].value.as < ast::Expression * > (), ast::Operator::DIV, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 2369 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 148: // muli_expr: muli_expr "%" cast_expr
#line 607 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                           { yylhs.value.as < ast::Expression * > () = driver.ctx.make_node<ast::Binop>(yystack_[2].value.as < ast::Expression * > (), ast::Operator::MOD, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 2375 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 149: // addi_expr: muli_expr
#line 611 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                           { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 2381 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 150: // addi_expr: addi_expr "+" muli_expr
#line 612 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                           { yylhs.value.as < ast::Expression * > () = driver.ctx.make_node<ast::Binop>(yystack_[2].value.as < ast::Expression * > (), ast::Operator::PLUS, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 2387 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 151: // addi_expr: addi_expr "-" muli_expr
#line 613 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                           { yylhs.value.as < ast::Expression * > () = driver.ctx.make_node<ast::Binop>(yystack_[2].value.as < ast::Expression * > (), ast::Operator::MINUS, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 2393 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 152: // cast_expr: unary_expr
#line 617 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                                            { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 2399 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 153: // cast_expr: "(" type ")" cast_expr
#line 618 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                                            { yylhs.value.as < ast::Expression * > () = driver.ctx.make_node<ast::Cast>(yystack_[2].value.as < SizedType > (), yystack_[0].value.as < ast::Expression * > (), yystack_[3].location + yystack_[1].location); }
#line 2405 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 154: // cast_expr: "(" "identifier" ")" cast_expr
#line 620 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                                            { yylhs.value.as < ast::Expression * > () = driver.ctx.make_node<ast::Cast>(ast::ident_to_record(yystack_[2].value.as < std::string > (), 0), yystack_[0].value.as < ast::Expression * > (), yystack_[3].location + yystack_[1].location); }
#line 2411 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 155: // cast_expr: "(" "identifier" "*" ")" cast_expr
#line 621 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                                            { yylhs.value.as < ast::Expression * > () = driver.ctx.make_node<ast::Cast>(ast::ident_to_record(yystack_[3].value.as < std::string > (), 1), yystack_[0].value.as < ast::Expression * > (), yystack_[4].location + yystack_[1].location); }
#line 2417 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 156: // cast_expr: "(" "identifier" "*" "*" ")" cast_expr
#line 622 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                                            { yylhs.value.as < ast::Expression * > () = driver.ctx.make_node<ast::Cast>(ast::ident_to_record(yystack_[4].value.as < std::string > (), 2), yystack_[0].value.as < ast::Expression * > (), yystack_[5].location + yystack_[1].location); }
#line 2423 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 157: // sizeof_expr: "sizeof" "(" type ")"
#line 626 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                                            { yylhs.value.as < ast::Sizeof * > () = driver.ctx.make_node<ast::Sizeof>(yystack_[1].value.as < SizedType > (), yylhs.location); }
#line 2429 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 158: // sizeof_expr: "sizeof" "(" expr ")"
#line 627 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                                            { yylhs.value.as < ast::Sizeof * > () = driver.ctx.make_node<ast::Sizeof>(yystack_[1].value.as < ast::Expression * > (), yylhs.location); }
#line 2435 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 159: // offsetof_expr: "offsetof" "(" struct_type "," struct_field ")"
#line 631 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                                                   { yylhs.value.as < ast::Offsetof * > () = driver.ctx.make_node<ast::Offsetof>(yystack_[3].value.as < SizedType > (), yystack_[1].value.as < std::vector<std::string> > (), yylhs.location); }
#line 2441 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 160: // offsetof_expr: "offsetof" "(" expr "," struct_field ")"
#line 633 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                                                   { yylhs.value.as < ast::Offsetof * > () = driver.ctx.make_node<ast::Offsetof>(yystack_[3].value.as < ast::Expression * > (), yystack_[1].value.as < std::vector<std::string> > (), yylhs.location); }
#line 2447 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 161: // int: "-" "integer"
#line 637 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                             { yylhs.value.as < ast::Integer * > () = driver.ctx.make_node<ast::Integer>((int64_t)(~(uint64_t)(yystack_[0].value.as < int64_t > ()) + 1), yylhs.location, true); }
#line 2453 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 162: // int: "integer"
#line 638 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                             { yylhs.value.as < ast::Integer * > () = driver.ctx.make_node<ast::Integer>(yystack_[0].value.as < int64_t > (), yylhs.location, false); }
#line 2459 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 163: // keyword: "break"
#line 642 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                              { yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > (); }
#line 2465 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 164: // keyword: "config"
#line 643 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                              { yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > (); }
#line 2471 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 165: // keyword: "continue"
#line 644 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                              { yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > (); }
#line 2477 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 166: // keyword: "else"
#line 645 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                              { yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > (); }
#line 2483 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 167: // keyword: "for"
#line 646 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                              { yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > (); }
#line 2489 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 168: // keyword: "if"
#line 647 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                              { yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > (); }
#line 2495 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 169: // keyword: "let"
#line 648 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                              { yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > (); }
#line 2501 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 170: // keyword: "offsetof"
#line 649 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                              { yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > (); }
#line 2507 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 171: // keyword: "return"
#line 650 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                              { yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > (); }
#line 2513 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 172: // keyword: "sizeof"
#line 651 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                              { yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > (); }
#line 2519 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 173: // keyword: "unroll"
#line 652 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                              { yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > (); }
#line 2525 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 174: // keyword: "while"
#line 653 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                              { yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > (); }
#line 2531 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 175: // keyword: "subprog"
#line 654 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                              { yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > (); }
#line 2537 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 176: // ident: "identifier"
#line 658 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                              { yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > (); }
#line 2543 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 177: // ident: "builtin"
#line 659 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                              { yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > (); }
#line 2549 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 178: // ident: "builtin type"
#line 660 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                              { yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > (); }
#line 2555 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 179: // ident: "call"
#line 661 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                              { yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > (); }
#line 2561 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 180: // ident: "call_builtin"
#line 662 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                              { yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > (); }
#line 2567 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 181: // ident: "stack_mode"
#line 663 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                              { yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > (); }
#line 2573 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 182: // struct_field: external_name
#line 667 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                                    { yylhs.value.as < std::vector<std::string> > ().push_back(yystack_[0].value.as < std::string > ()); }
#line 2579 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 183: // struct_field: struct_field "." external_name
#line 668 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                                    { yylhs.value.as < std::vector<std::string> > () = std::move(yystack_[2].value.as < std::vector<std::string> > ()); yylhs.value.as < std::vector<std::string> > ().push_back(yystack_[0].value.as < std::string > ()); }
#line 2585 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 184: // external_name: keyword
#line 672 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                              { yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > (); }
#line 2591 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 185: // external_name: ident
#line 673 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                              { yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > (); }
#line 2597 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 186: // call: "call" "(" ")"
#line 677 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                             { yylhs.value.as < ast::Call * > () = driver.ctx.make_node<ast::Call>(yystack_[2].value.as < std::string > (), yylhs.location); }
#line 2603 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 187: // call: "call" "(" vargs ")"
#line 678 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                             { yylhs.value.as < ast::Call * > () = driver.ctx.make_node<ast::Call>(yystack_[3].value.as < std::string > (), std::move(yystack_[1].value.as < ast::ExpressionList > ()), yylhs.location); }
#line 2609 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 188: // call: "call_builtin" "(" ")"
#line 679 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                             { yylhs.value.as < ast::Call * > () = driver.ctx.make_node<ast::Call>(yystack_[2].value.as < std::string > (), yylhs.location); }
#line 2615 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 189: // call: "call_builtin" "(" vargs ")"
#line 680 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                             { yylhs.value.as < ast::Call * > () = driver.ctx.make_node<ast::Call>(yystack_[3].value.as < std::string > (), std::move(yystack_[1].value.as < ast::ExpressionList > ()), yylhs.location); }
#line 2621 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 190: // call: "identifier" "(" ")"
#line 681 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                             { error(yystack_[2].location, "Unknown function: " + yystack_[2].value.as < std::string > ()); YYERROR;  }
#line 2627 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 191: // call: "identifier" "(" vargs ")"
#line 682 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                             { error(yystack_[3].location, "Unknown function: " + yystack_[3].value.as < std::string > ()); YYERROR;  }
#line 2633 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 192: // call: "builtin" "(" ")"
#line 683 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                             { error(yystack_[2].location, "Unknown function: " + yystack_[2].value.as < std::string > ()); YYERROR;  }
#line 2639 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 193: // call: "builtin" "(" vargs ")"
#line 684 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                             { error(yystack_[3].location, "Unknown function: " + yystack_[3].value.as < std::string > ()); YYERROR;  }
#line 2645 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 194: // call: "stack_mode" "(" ")"
#line 685 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                             { error(yystack_[2].location, "Unknown function: " + yystack_[2].value.as < std::string > ()); YYERROR;  }
#line 2651 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 195: // call: "stack_mode" "(" vargs ")"
#line 686 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                             { error(yystack_[3].location, "Unknown function: " + yystack_[3].value.as < std::string > ()); YYERROR;  }
#line 2657 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 196: // map: "map"
#line 690 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                  { yylhs.value.as < ast::Map * > () = driver.ctx.make_node<ast::Map>(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 2663 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 197: // map: "map" "[" vargs "]"
#line 691 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                                  {
                        if (yystack_[1].value.as < ast::ExpressionList > ().size() > 1) {
                          auto t = driver.ctx.make_node<ast::Tuple>(std::move(yystack_[1].value.as < ast::ExpressionList > ()), yylhs.location);
                          yylhs.value.as < ast::Map * > () = driver.ctx.make_node<ast::Map>(yystack_[3].value.as < std::string > (), *t, yylhs.location);
                        } else {
                          yylhs.value.as < ast::Map * > () = driver.ctx.make_node<ast::Map>(yystack_[3].value.as < std::string > (), *yystack_[1].value.as < ast::ExpressionList > ().back(), yylhs.location);
                        }
                }
#line 2676 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 198: // var: "variable"
#line 702 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                    { yylhs.value.as < ast::Variable * > () = driver.ctx.make_node<ast::Variable>(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 2682 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 199: // map_or_var: var
#line 706 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                    { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Variable * > (); }
#line 2688 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 200: // map_or_var: map
#line 707 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                    { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Map * > (); }
#line 2694 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 201: // vargs: vargs "," expr
#line 711 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                               { yylhs.value.as < ast::ExpressionList > () = std::move(yystack_[2].value.as < ast::ExpressionList > ()); yylhs.value.as < ast::ExpressionList > ().push_back(yystack_[0].value.as < ast::Expression * > ()); }
#line 2700 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 202: // vargs: expr
#line 712 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                               { yylhs.value.as < ast::ExpressionList > () = ast::ExpressionList{yystack_[0].value.as < ast::Expression * > ()}; }
#line 2706 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 203: // compound_op: "<<="
#line 716 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                             { yylhs.value.as < ast::Operator > () = ast::Operator::LEFT; }
#line 2712 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 204: // compound_op: "&="
#line 717 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                             { yylhs.value.as < ast::Operator > () = ast::Operator::BAND; }
#line 2718 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 205: // compound_op: "|="
#line 718 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                             { yylhs.value.as < ast::Operator > () = ast::Operator::BOR; }
#line 2724 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 206: // compound_op: "^="
#line 719 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                             { yylhs.value.as < ast::Operator > () = ast::Operator::BXOR; }
#line 2730 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 207: // compound_op: "/="
#line 720 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                             { yylhs.value.as < ast::Operator > () = ast::Operator::DIV; }
#line 2736 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 208: // compound_op: "-="
#line 721 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                             { yylhs.value.as < ast::Operator > () = ast::Operator::MINUS; }
#line 2742 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 209: // compound_op: "%="
#line 722 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                             { yylhs.value.as < ast::Operator > () = ast::Operator::MOD; }
#line 2748 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 210: // compound_op: "*="
#line 723 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                             { yylhs.value.as < ast::Operator > () = ast::Operator::MUL; }
#line 2754 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 211: // compound_op: "+="
#line 724 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                             { yylhs.value.as < ast::Operator > () = ast::Operator::PLUS; }
#line 2760 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;

  case 212: // compound_op: ">>="
#line 725 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
                             { yylhs.value.as < ast::Operator > () = ast::Operator::RIGHT; }
#line 2766 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"
    break;


#line 2770 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"

            default:
              break;
            }
        }
#if YY_EXCEPTIONS
      catch (const syntax_error& yyexc)
        {
          YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
          error (yyexc);
          YYERROR;
        }
#endif // YY_EXCEPTIONS
      YY_SYMBOL_PRINT ("-> $$ =", yylhs);
      yypop_ (yylen);
      yylen = 0;

      // Shift the result of the reduction.
      yypush_ (YY_NULLPTR, YY_MOVE (yylhs));
    }
    goto yynewstate;


  /*--------------------------------------.
  | yyerrlab -- here on detecting error.  |
  `--------------------------------------*/
  yyerrlab:
    // If not already recovering from an error, report this error.
    if (!yyerrstatus_)
      {
        ++yynerrs_;
        context yyctx (*this, yyla);
        std::string msg = yysyntax_error_ (yyctx);
        error (yyla.location, YY_MOVE (msg));
      }


    yyerror_range[1].location = yyla.location;
    if (yyerrstatus_ == 3)
      {
        /* If just tried and failed to reuse lookahead token after an
           error, discard it.  */

        // Return failure if at end of input.
        if (yyla.kind () == symbol_kind::S_YYEOF)
          YYABORT;
        else if (!yyla.empty ())
          {
            yy_destroy_ ("Error: discarding", yyla);
            yyla.clear ();
          }
      }

    // Else will try to reuse lookahead token after shifting the error token.
    goto yyerrlab1;


  /*---------------------------------------------------.
  | yyerrorlab -- error raised explicitly by YYERROR.  |
  `---------------------------------------------------*/
  yyerrorlab:
    /* Pacify compilers when the user code never invokes YYERROR and
       the label yyerrorlab therefore never appears in user code.  */
    if (false)
      YYERROR;

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYERROR.  */
    yypop_ (yylen);
    yylen = 0;
    YY_STACK_PRINT ();
    goto yyerrlab1;


  /*-------------------------------------------------------------.
  | yyerrlab1 -- common code for both syntax error and YYERROR.  |
  `-------------------------------------------------------------*/
  yyerrlab1:
    yyerrstatus_ = 3;   // Each real token shifted decrements this.
    // Pop stack until we find a state that shifts the error token.
    for (;;)
      {
        yyn = yypact_[+yystack_[0].state];
        if (!yy_pact_value_is_default_ (yyn))
          {
            yyn += symbol_kind::S_YYerror;
            if (0 <= yyn && yyn <= yylast_
                && yycheck_[yyn] == symbol_kind::S_YYerror)
              {
                yyn = yytable_[yyn];
                if (0 < yyn)
                  break;
              }
          }

        // Pop the current state because it cannot handle the error token.
        if (yystack_.size () == 1)
          YYABORT;

        yyerror_range[1].location = yystack_[0].location;
        yy_destroy_ ("Error: popping", yystack_[0]);
        yypop_ ();
        YY_STACK_PRINT ();
      }
    {
      stack_symbol_type error_token;

      yyerror_range[2].location = yyla.location;
      YYLLOC_DEFAULT (error_token.location, yyerror_range, 2);

      // Shift the error token.
      error_token.state = state_type (yyn);
      yypush_ ("Shifting", YY_MOVE (error_token));
    }
    goto yynewstate;


  /*-------------------------------------.
  | yyacceptlab -- YYACCEPT comes here.  |
  `-------------------------------------*/
  yyacceptlab:
    yyresult = 0;
    goto yyreturn;


  /*-----------------------------------.
  | yyabortlab -- YYABORT comes here.  |
  `-----------------------------------*/
  yyabortlab:
    yyresult = 1;
    goto yyreturn;


  /*-----------------------------------------------------.
  | yyreturn -- parsing is finished, return the result.  |
  `-----------------------------------------------------*/
  yyreturn:
    if (!yyla.empty ())
      yy_destroy_ ("Cleanup: discarding lookahead", yyla);

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYABORT or YYACCEPT.  */
    yypop_ (yylen);
    YY_STACK_PRINT ();
    while (1 < yystack_.size ())
      {
        yy_destroy_ ("Cleanup: popping", yystack_[0]);
        yypop_ ();
      }

    return yyresult;
  }
#if YY_EXCEPTIONS
    catch (...)
      {
        YYCDEBUG << "Exception caught: cleaning lookahead and stack\n";
        // Do not try to display the values of the reclaimed symbols,
        // as their printers might throw an exception.
        if (!yyla.empty ())
          yy_destroy_ (YY_NULLPTR, yyla);

        while (1 < yystack_.size ())
          {
            yy_destroy_ (YY_NULLPTR, yystack_[0]);
            yypop_ ();
          }
        throw;
      }
#endif // YY_EXCEPTIONS
  }

  void
  Parser::error (const syntax_error& yyexc)
  {
    error (yyexc.location, yyexc.what ());
  }

  /* Return YYSTR after stripping away unnecessary quotes and
     backslashes, so that it's suitable for yyerror.  The heuristic is
     that double-quoting is unnecessary unless the string contains an
     apostrophe, a comma, or backslash (other than backslash-backslash).
     YYSTR is taken from yytname.  */
  std::string
  Parser::yytnamerr_ (const char *yystr)
  {
    if (*yystr == '"')
      {
        std::string yyr;
        char const *yyp = yystr;

        for (;;)
          switch (*++yyp)
            {
            case '\'':
            case ',':
              goto do_not_strip_quotes;

            case '\\':
              if (*++yyp != '\\')
                goto do_not_strip_quotes;
              else
                goto append;

            append:
            default:
              yyr += *yyp;
              break;

            case '"':
              return yyr;
            }
      do_not_strip_quotes: ;
      }

    return yystr;
  }

  std::string
  Parser::symbol_name (symbol_kind_type yysymbol)
  {
    return yytnamerr_ (yytname_[yysymbol]);
  }



  // Parser::context.
  Parser::context::context (const Parser& yyparser, const symbol_type& yyla)
    : yyparser_ (yyparser)
    , yyla_ (yyla)
  {}

  int
  Parser::context::expected_tokens (symbol_kind_type yyarg[], int yyargn) const
  {
    // Actual number of expected tokens
    int yycount = 0;

    const int yyn = yypact_[+yyparser_.yystack_[0].state];
    if (!yy_pact_value_is_default_ (yyn))
      {
        /* Start YYX at -YYN if negative to avoid negative indexes in
           YYCHECK.  In other words, skip the first -YYN actions for
           this state because they are default actions.  */
        const int yyxbegin = yyn < 0 ? -yyn : 0;
        // Stay within bounds of both yycheck and yytname.
        const int yychecklim = yylast_ - yyn + 1;
        const int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
        for (int yyx = yyxbegin; yyx < yyxend; ++yyx)
          if (yycheck_[yyx + yyn] == yyx && yyx != symbol_kind::S_YYerror
              && !yy_table_value_is_error_ (yytable_[yyx + yyn]))
            {
              if (!yyarg)
                ++yycount;
              else if (yycount == yyargn)
                return 0;
              else
                yyarg[yycount++] = YY_CAST (symbol_kind_type, yyx);
            }
      }

    if (yyarg && yycount == 0 && 0 < yyargn)
      yyarg[0] = symbol_kind::S_YYEMPTY;
    return yycount;
  }






  int
  Parser::yy_syntax_error_arguments_ (const context& yyctx,
                                                 symbol_kind_type yyarg[], int yyargn) const
  {
    /* There are many possibilities here to consider:
       - If this state is a consistent state with a default action, then
         the only way this function was invoked is if the default action
         is an error action.  In that case, don't check for expected
         tokens because there are none.
       - The only way there can be no lookahead present (in yyla) is
         if this state is a consistent state with a default action.
         Thus, detecting the absence of a lookahead is sufficient to
         determine that there is no unexpected or expected token to
         report.  In that case, just report a simple "syntax error".
       - Don't assume there isn't a lookahead just because this state is
         a consistent state with a default action.  There might have
         been a previous inconsistent state, consistent state with a
         non-default action, or user semantic action that manipulated
         yyla.  (However, yyla is currently not documented for users.)
       - Of course, the expected token list depends on states to have
         correct lookahead information, and it depends on the parser not
         to perform extra reductions after fetching a lookahead from the
         scanner and before detecting a syntax error.  Thus, state merging
         (from LALR or IELR) and default reductions corrupt the expected
         token list.  However, the list is correct for canonical LR with
         one exception: it will still contain any token that will not be
         accepted due to an error action in a later state.
    */

    if (!yyctx.lookahead ().empty ())
      {
        if (yyarg)
          yyarg[0] = yyctx.token ();
        int yyn = yyctx.expected_tokens (yyarg ? yyarg + 1 : yyarg, yyargn - 1);
        return yyn + 1;
      }
    return 0;
  }

  // Generate an error message.
  std::string
  Parser::yysyntax_error_ (const context& yyctx) const
  {
    // Its maximum.
    enum { YYARGS_MAX = 5 };
    // Arguments of yyformat.
    symbol_kind_type yyarg[YYARGS_MAX];
    int yycount = yy_syntax_error_arguments_ (yyctx, yyarg, YYARGS_MAX);

    char const* yyformat = YY_NULLPTR;
    switch (yycount)
      {
#define YYCASE_(N, S)                         \
        case N:                               \
          yyformat = S;                       \
        break
      default: // Avoid compiler warnings.
        YYCASE_ (0, YY_("syntax error"));
        YYCASE_ (1, YY_("syntax error, unexpected %s"));
        YYCASE_ (2, YY_("syntax error, unexpected %s, expecting %s"));
        YYCASE_ (3, YY_("syntax error, unexpected %s, expecting %s or %s"));
        YYCASE_ (4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
        YYCASE_ (5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
      }

    std::string yyres;
    // Argument number.
    std::ptrdiff_t yyi = 0;
    for (char const* yyp = yyformat; *yyp; ++yyp)
      if (yyp[0] == '%' && yyp[1] == 's' && yyi < yycount)
        {
          yyres += symbol_name (yyarg[yyi++]);
          ++yyp;
        }
      else
        yyres += *yyp;
    return yyres;
  }


  const short Parser::yypact_ninf_ = -248;

  const short Parser::yytable_ninf_ = -182;

  const short
  Parser::yypact_[] =
  {
      38,   154,    38,    83,   -46,    38,    38,  -248,  -248,    29,
      39,  -248,  -248,   103,    86,  -248,    14,  -248,    17,  -248,
     535,  -248,  -248,   142,  -248,  -248,  -248,  -248,  -248,   513,
     152,  -248,  -248,  -248,  -248,  -248,  -248,  -248,  -248,  -248,
    -248,  -248,  -248,  -248,  -248,  -248,  -248,  -248,  -248,  -248,
      23,     6,  -248,   253,   139,    94,   139,  -248,  -248,  -248,
      24,   161,    89,    98,  -248,   176,  -248,  -248,   149,   214,
     234,  -248,  -248,    13,  -248,  -248,   513,   242,  -248,    21,
     246,   222,   226,   229,   221,   178,   220,    90,    -7,  -248,
    -248,  -248,  -248,    -4,  -248,  -248,  -248,    -2,  -248,  -248,
    -248,   258,   118,   271,   272,   113,  -248,   223,  -248,    -1,
     274,   109,    12,   276,  -248,   277,   269,   273,  -248,  -248,
    -248,  -248,  -248,     1,   180,   349,   384,   513,   432,   288,
     467,   513,   553,   583,  -248,  -248,   513,   513,   513,   513,
     513,   513,   513,   513,   513,   513,   513,   513,   513,   513,
     513,   513,   513,   513,   513,  -248,  -248,  -248,  -248,   100,
     513,  -248,  -248,   105,   105,   282,   228,  -248,   219,   513,
      54,   513,  -248,     5,   227,  -248,   513,  -248,  -248,   172,
    -248,   174,  -248,   189,  -248,   211,    79,  -248,   212,    75,
     278,   283,   285,   281,  -248,  -248,  -248,  -248,  -248,  -248,
    -248,  -248,  -248,  -248,  -248,  -248,  -248,  -248,  -248,  -248,
    -248,  -248,   287,   246,   222,   226,   229,   221,   178,   178,
     220,   220,   220,   220,    -7,    -7,  -248,  -248,  -248,    90,
      90,  -248,   292,   295,   301,   513,   307,  -248,  -248,   257,
    -248,   224,  -248,  -248,  -248,  -248,  -248,    96,   309,  -248,
     650,   660,  -248,  -248,    44,   289,   105,  -248,   317,  -248,
     513,   320,  -248,  -248,   323,   328,   327,  -248,   513,  -248,
    -248,  -248,  -248,  -248,  -248,  -248,   583,   583,  -248,   513,
       7,   513,   257,  -248,   513,   336,  -248,  -248,  -248,   513,
     513,   513,  -248,  -248,  -248,  -248,  -248,  -248,  -248,  -248,
    -248,  -248,   513,   513,   513,  -248,    44,  -248,  -248,   513,
    -248,  -248,  -248,  -248,     2,  -248,     8,  -248,    94,   335,
     338,   339,   347,   341,   105,  -248,  -248,  -248,  -248,  -248,
    -248,  -248,  -248,  -248,   583,  -248,   152,   152,   152,   513,
     152,   289,  -248,  -248,  -248,  -248,   350,   286,   152,     4,
    -248,  -248,  -248,  -248
  };

  const unsigned char
  Parser::yydefact_[] =
  {
       6,     0,     6,     0,    20,     6,     6,     3,     1,     0,
      51,     4,     5,     0,     0,    34,    51,    33,    53,    38,
      39,    24,    19,     0,     2,    32,    31,    36,    51,     0,
       0,    44,    48,    49,    55,    46,    47,    45,   177,   179,
     180,   178,   176,    42,    41,    54,    43,   181,    50,    40,
       0,     0,    37,     0,     0,   120,     0,   117,   119,   118,
      92,   179,    93,    88,    90,   196,   198,   162,    91,     0,
       0,    95,    98,   112,   101,   152,     0,     0,   121,   122,
     124,   126,   128,   130,   132,   134,   137,   149,   142,   145,
     104,   105,    89,     0,   103,   200,   199,    96,    61,    35,
      21,     0,     0,     0,     0,     0,    29,     0,    16,     8,
       9,    88,     0,     7,    14,    15,   202,     0,   108,   113,
     161,   109,   114,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   111,    52,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   116,   115,   106,   107,     0,
       0,    23,    22,     0,     0,     0,     0,    18,     0,     0,
       0,     0,    17,     0,     0,    94,     0,   192,   202,     0,
     186,     0,   188,     0,   190,     0,     0,   194,     0,     0,
       0,     0,     0,     0,   175,   110,   164,   173,   174,   167,
     171,   168,   166,   165,   163,   172,   170,   169,   184,   185,
      99,   100,     0,   125,   127,   129,   131,   133,   135,   136,
     138,   139,   140,   141,   143,   144,   146,   147,   148,   150,
     151,    56,     0,     0,     0,    70,     0,    69,    68,     0,
      59,     0,    66,    62,    64,    63,    67,     0,   101,    65,
     200,   199,    25,     8,     0,    30,     0,    28,     0,   154,
       0,     0,   153,    13,     0,     0,   201,   193,     0,   187,
     189,   191,   197,   195,   157,   158,     0,     0,   102,     0,
       0,     0,     0,    71,     0,    86,    58,    57,    60,     0,
       0,     0,   203,   212,   211,   208,   210,   207,   209,   204,
     205,   206,     0,     0,     0,    27,     0,    10,   155,     0,
      11,    12,    97,   201,     0,   182,     0,   123,     0,     0,
       0,     0,     0,     0,     0,    82,    80,    81,    84,    83,
      85,    26,   156,   159,     0,   160,     0,     0,     0,     0,
       0,    87,   183,    73,    72,    74,     0,    76,     0,     0,
      75,    78,    79,    77
  };

  const short
  Parser::yypgoto_[] =
  {
    -248,  -248,   115,  -121,  -248,  -248,   231,  -248,  -248,  -248,
    -248,   348,  -248,   199,  -248,   353,  -248,   342,  -248,  -248,
     -19,  -247,  -248,  -248,  -248,  -248,  -248,  -248,    22,  -248,
    -248,  -248,  -248,  -248,   207,  -248,  -248,   -26,    93,  -248,
     236,   237,   235,   238,   239,   108,    -3,    99,   120,   -74,
    -248,  -248,    97,  -248,   -20,   102,  -128,  -248,   225,  -153,
     175,    87,   130
  };

  const short
  Parser::yydefgoto_[] =
  {
       0,     3,     4,   112,   113,   114,   115,    10,    22,    50,
     102,    15,   105,   106,    16,    17,    18,    19,    20,    30,
      71,    99,   159,   240,   241,   242,   243,   244,   245,   353,
     246,   247,    72,    73,    74,    75,    76,   178,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,   208,    93,   314,   315,    94,    95,    96,
      97,   117,   302
  };

  const short
  Parser::yytable_[] =
  {
      49,    48,   134,    77,   210,   211,   251,   305,   189,    98,
      53,   177,   333,   263,    24,    34,   103,    27,   335,   153,
     131,    34,   171,   155,     9,   157,  -178,   116,    54,   100,
      28,   154,   136,   123,   118,   156,   121,   158,  -178,    55,
      56,    57,   254,   255,    13,   318,   137,    58,    59,    98,
     334,  -177,   172,    60,    61,    62,   334,    41,    29,   331,
      63,   132,   133,  -177,   260,    64,    65,    66,    45,    67,
      68,    14,   104,   264,    45,    67,   226,   227,   228,   236,
      69,    70,   101,     8,   172,   274,   285,   272,     1,   343,
     344,   345,   268,   347,   261,   259,    14,   262,   125,     2,
     288,   350,   351,   190,   192,   193,   231,   126,    21,    53,
     212,   289,   209,   209,    34,   172,  -180,     7,   126,   169,
      11,    12,   161,   165,   162,  -176,   166,    54,  -180,   322,
     150,   151,   152,   249,   252,   306,  -176,  -176,    55,    56,
      57,   220,   221,   222,   223,    23,    58,    59,  -176,   170,
     266,    51,    60,    61,    62,   107,    41,    98,   128,    63,
     108,   253,   120,   110,    64,    65,    66,    45,    67,    68,
     124,   232,   233,   234,   235,   236,  -181,   237,   238,    69,
      70,   239,   267,   127,   269,   268,   308,   268,  -181,    53,
     180,    38,    39,    40,    34,    41,   144,   145,    42,   270,
     146,   147,   268,   341,    65,    66,   342,    54,    47,   283,
     179,   181,   183,   185,   186,   188,     5,     6,    55,    56,
      57,   271,   273,   129,   268,   268,    58,    59,   286,   119,
     287,   122,    60,    61,    62,   332,    41,   142,   143,    63,
     148,   149,   313,   130,    64,    65,    66,    45,    67,    68,
     218,   219,   229,   230,   135,   321,   209,   209,   323,    69,
      70,   319,    53,   325,   326,   327,   139,    34,   224,   225,
     138,   140,   141,   160,   163,   164,   328,   329,   330,   175,
      54,   168,   167,   173,   174,   256,   176,   258,   275,   278,
     279,    55,    56,    57,   104,   265,   276,    53,   277,    58,
      59,   280,    34,   107,   281,    60,    61,    62,   108,   109,
     282,   110,   111,   346,   209,    54,   284,    64,    65,    66,
      45,    67,    68,    66,   290,   307,    55,    56,    57,   172,
     309,   310,    69,    70,    58,    59,   311,   312,   107,   324,
      60,    61,    62,   108,   109,   336,   110,    63,   337,   338,
     339,   340,    64,    65,    66,    45,    67,    68,    53,   182,
     348,   191,   349,    34,    25,   257,   248,    69,    70,    26,
      52,   352,   317,   213,   215,   214,    54,   320,   216,   316,
     217,   304,     0,     0,   250,     0,     0,    55,    56,    57,
       0,     0,     0,    53,   184,    58,    59,     0,    34,     0,
       0,    60,    61,    62,     0,    41,     0,     0,    63,     0,
       0,    54,     0,    64,    65,    66,    45,    67,    68,     0,
       0,     0,    55,    56,    57,     0,     0,     0,    69,    70,
      58,    59,     0,     0,     0,     0,    60,    61,    62,     0,
      41,    53,   187,    63,     0,     0,    34,     0,    64,    65,
      66,    45,    67,    68,     0,     0,     0,     0,     0,    54,
       0,     0,     0,    69,    70,     0,     0,     0,     0,     0,
      55,    56,    57,     0,     0,     0,    53,     0,    58,    59,
       0,    34,     0,     0,    60,    61,    62,     0,    41,     0,
       0,    63,     0,     0,    54,     0,    64,    65,    66,    45,
      67,    68,     0,     0,     0,    55,    56,    57,     0,     0,
       0,    69,    70,    58,    59,     0,     0,   107,     0,    60,
      61,    62,    53,    41,     0,     0,    63,    34,     0,     0,
       0,    64,    65,    66,    45,    67,    68,     0,    31,     0,
      54,     0,    32,    33,     0,     0,    69,    70,     0,    34,
       0,    55,    56,    57,     0,     0,     0,     0,     0,    58,
      59,    35,     0,     0,     0,    60,    61,    62,     0,    41,
       0,     0,    63,     0,     0,    36,     0,    64,    65,    66,
      45,    67,    68,    37,     0,     0,     0,    38,    39,    40,
       0,    41,    69,    70,    42,    43,     0,     0,     0,    44,
       0,     0,    45,    46,    47,    38,    39,    40,     0,    41,
     194,     0,    42,     0,     0,     0,     0,     0,     0,     0,
       0,   195,    47,   196,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,   207,    38,    39,    40,     0,    41,
     194,     0,    42,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    47,   196,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   291,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   303,     0,     0,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301
  };

  const short
  Parser::yycheck_[] =
  {
      20,    20,    76,    29,   132,   133,   159,   254,   129,     5,
       9,    10,    10,     8,     0,    14,    10,     0,    10,    26,
       7,    14,    10,    27,    70,    27,    27,    53,    27,     6,
      13,    38,    11,     9,    54,    39,    56,    39,    39,    38,
      39,    40,   163,   164,    15,    38,    25,    46,    47,     5,
      48,    27,    40,    52,    53,    54,    48,    56,    41,   306,
      59,    48,    49,    39,    10,    64,    65,    66,    67,    68,
      69,    57,    66,    68,    67,    68,   150,   151,   152,    75,
      79,    80,    59,     0,    40,    10,   239,     8,    50,   336,
     337,   338,    13,   340,    40,   169,    57,   171,     9,    61,
       4,   348,   349,   129,   130,   131,     6,     9,     5,     9,
     136,    15,   132,   133,    14,    40,    27,     2,     9,    10,
       5,     6,     4,    10,     6,    27,    13,    27,    39,   282,
      40,    41,    42,   159,   160,   256,    27,    39,    38,    39,
      40,   144,   145,   146,   147,    59,    46,    47,    39,    40,
     176,     9,    52,    53,    54,    50,    56,     5,     9,    59,
      55,    56,    68,    58,    64,    65,    66,    67,    68,    69,
       9,    71,    72,    73,    74,    75,    27,    77,    78,    79,
      80,    81,    10,     7,    10,    13,   260,    13,    39,     9,
      10,    52,    53,    54,    14,    56,    18,    19,    59,    10,
      22,    23,    13,   324,    65,    66,   334,    27,    69,   235,
     123,   124,   125,   126,   127,   128,    62,    63,    38,    39,
      40,    10,    10,     9,    13,    13,    46,    47,     4,    54,
       6,    56,    52,    53,    54,   309,    56,    16,    17,    59,
      20,    21,   268,     9,    64,    65,    66,    67,    68,    69,
     142,   143,   153,   154,    12,   281,   276,   277,   284,    79,
      80,   280,     9,   289,   290,   291,    44,    14,   148,   149,
      24,    45,    43,    15,     3,     3,   302,   303,   304,    10,
      27,     7,    59,     7,     7,     3,    13,    68,    10,     8,
       3,    38,    39,    40,    66,    68,    13,     9,    13,    46,
      47,     9,    14,    50,     9,    52,    53,    54,    55,    56,
       9,    58,    59,   339,   334,    27,     9,    64,    65,    66,
      67,    68,    69,    66,    15,     8,    38,    39,    40,    40,
      10,     8,    79,    80,    46,    47,     8,    10,    50,     3,
      52,    53,    54,    55,    56,    10,    58,    59,    10,    10,
       3,    10,    64,    65,    66,    67,    68,    69,     9,    10,
      10,   130,    76,    14,    16,   166,   159,    79,    80,    16,
      28,   349,   279,   137,   139,   138,    27,   280,   140,   277,
     141,   251,    -1,    -1,   159,    -1,    -1,    38,    39,    40,
      -1,    -1,    -1,     9,    10,    46,    47,    -1,    14,    -1,
      -1,    52,    53,    54,    -1,    56,    -1,    -1,    59,    -1,
      -1,    27,    -1,    64,    65,    66,    67,    68,    69,    -1,
      -1,    -1,    38,    39,    40,    -1,    -1,    -1,    79,    80,
      46,    47,    -1,    -1,    -1,    -1,    52,    53,    54,    -1,
      56,     9,    10,    59,    -1,    -1,    14,    -1,    64,    65,
      66,    67,    68,    69,    -1,    -1,    -1,    -1,    -1,    27,
      -1,    -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,
      38,    39,    40,    -1,    -1,    -1,     9,    -1,    46,    47,
      -1,    14,    -1,    -1,    52,    53,    54,    -1,    56,    -1,
      -1,    59,    -1,    -1,    27,    -1,    64,    65,    66,    67,
      68,    69,    -1,    -1,    -1,    38,    39,    40,    -1,    -1,
      -1,    79,    80,    46,    47,    -1,    -1,    50,    -1,    52,
      53,    54,     9,    56,    -1,    -1,    59,    14,    -1,    -1,
      -1,    64,    65,    66,    67,    68,    69,    -1,     3,    -1,
      27,    -1,     7,     8,    -1,    -1,    79,    80,    -1,    14,
      -1,    38,    39,    40,    -1,    -1,    -1,    -1,    -1,    46,
      47,    26,    -1,    -1,    -1,    52,    53,    54,    -1,    56,
      -1,    -1,    59,    -1,    -1,    40,    -1,    64,    65,    66,
      67,    68,    69,    48,    -1,    -1,    -1,    52,    53,    54,
      -1,    56,    79,    80,    59,    60,    -1,    -1,    -1,    64,
      -1,    -1,    67,    68,    69,    52,    53,    54,    -1,    56,
      57,    -1,    59,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    52,    53,    54,    -1,    56,
      57,    -1,    59,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    15,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    15,    -1,    -1,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37
  };

  const unsigned char
  Parser::yystos_[] =
  {
       0,    50,    61,    83,    84,    62,    63,    84,     0,    70,
      89,    84,    84,    15,    57,    93,    96,    97,    98,    99,
     100,     5,    90,    59,     0,    93,    97,     0,    13,    41,
     101,     3,     7,     8,    14,    26,    40,    48,    52,    53,
      54,    56,    59,    60,    64,    67,    68,    69,   102,   136,
      91,     9,    99,     9,    27,    38,    39,    40,    46,    47,
      52,    53,    54,    59,    64,    65,    66,    68,    69,    79,
      80,   102,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   136,   139,   140,   141,   142,     5,   103,
       6,    59,    92,    10,    66,    94,    95,    50,    55,    56,
      58,    59,    85,    86,    87,    88,   119,   143,   136,   142,
      68,   136,   142,     9,     9,     9,     9,     7,     9,     9,
       9,     7,    48,    49,   131,    12,    11,    25,    24,    44,
      45,    43,    16,    17,    18,    19,    22,    23,    20,    21,
      40,    41,    42,    26,    38,    27,    39,    27,    39,   104,
      15,     4,     6,     3,     3,    10,    13,    59,     7,    10,
      40,    10,    40,     7,     7,    10,    13,    10,   119,   143,
      10,   143,    10,   143,    10,   143,   143,    10,   143,    85,
     119,    88,   119,   119,    57,    68,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,   135,   136,
     138,   138,   119,   122,   123,   124,   125,   126,   127,   127,
     128,   128,   128,   128,   130,   130,   131,   131,   131,   129,
     129,     6,    71,    72,    73,    74,    75,    77,    78,    81,
     105,   106,   107,   108,   109,   110,   112,   113,   116,   119,
     140,   141,   119,    56,    85,    85,     3,    95,    68,   131,
      10,    40,   131,     8,    68,    68,   119,    10,    13,    10,
      10,    10,     8,    10,    10,    10,    13,    13,     8,     3,
       9,     9,     9,   119,     9,   141,     4,     6,     4,    15,
      15,    15,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,   144,    15,   144,   103,    85,     8,   131,    10,
       8,     8,    10,   119,   137,   138,   137,   120,    38,   102,
     134,   119,   141,   119,     3,   119,   119,   119,   119,   119,
     119,   103,   131,    10,    48,    10,    10,    10,    10,     3,
      10,    85,   138,   103,   103,   103,   119,   103,    10,    76,
     103,   103,   110,   111
  };

  const unsigned char
  Parser::yyr1_[] =
  {
       0,    82,    83,    84,    84,    84,    84,    85,    85,    85,
      85,    85,    85,    85,    85,    85,    86,    87,    88,    89,
      89,    90,    90,    91,    91,    92,    93,    93,    94,    94,
      95,    96,    96,    96,    96,    97,    97,    98,    98,    99,
     100,   100,   100,   100,   100,   100,   100,   100,   100,   100,
     100,   100,   101,   101,   102,   102,   103,   103,   104,   104,
     104,   104,   105,   105,   105,   106,   106,   106,   107,   107,
     107,   107,   108,   108,   108,   109,   110,   110,   111,   111,
     112,   112,   112,   112,   112,   112,   113,   113,   114,   114,
     114,   114,   114,   114,   114,   114,   114,   114,   115,   115,
     115,   115,   115,   115,   115,   115,   115,   115,   115,   115,
     116,   117,   117,   117,   117,   117,   117,   118,   118,   118,
     118,   119,   120,   120,   121,   121,   122,   122,   123,   123,
     124,   124,   125,   125,   126,   126,   126,   127,   127,   127,
     127,   127,   128,   128,   128,   129,   129,   129,   129,   130,
     130,   130,   131,   131,   131,   131,   131,   132,   132,   133,
     133,   134,   134,   135,   135,   135,   135,   135,   135,   135,
     135,   135,   135,   135,   135,   135,   136,   136,   136,   136,
     136,   136,   137,   137,   138,   138,   139,   139,   139,   139,
     139,   139,   139,   139,   139,   139,   140,   140,   141,   142,
     142,   143,   143,   144,   144,   144,   144,   144,   144,   144,
     144,   144,   144
  };

  const signed char
  Parser::yyr2_[] =
  {
       0,     2,     4,     2,     3,     3,     0,     1,     1,     1,
       4,     4,     4,     3,     1,     1,     1,     2,     2,     3,
       0,     3,     4,     3,     0,     3,     8,     7,     3,     1,
       3,     2,     2,     1,     1,     3,     2,     3,     1,     1,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     0,     3,     0,     1,     1,     3,     4,     3,     2,
       3,     0,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     5,     5,     5,     7,     5,     7,     1,     1,
       3,     3,     3,     3,     3,     3,     2,     4,     1,     1,
       1,     1,     1,     1,     3,     1,     1,     5,     1,     3,
       3,     1,     4,     1,     1,     1,     2,     2,     2,     2,
       3,     2,     1,     2,     2,     2,     2,     1,     1,     1,
       1,     1,     1,     5,     1,     3,     1,     3,     1,     3,
       1,     3,     1,     3,     1,     3,     3,     1,     3,     3,
       3,     3,     1,     3,     3,     1,     3,     3,     3,     1,
       3,     3,     1,     4,     4,     5,     6,     4,     4,     6,
       6,     2,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     3,     1,     1,     3,     4,     3,     4,
       3,     4,     3,     4,     3,     4,     1,     4,     1,     1,
       1,     3,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1
  };


#if YYDEBUG || 1
  // YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
  // First, the terminals, then, starting at \a YYNTOKENS, nonterminals.
  const char*
  const Parser::yytname_[] =
  {
  "\"end of file\"", "error", "\"invalid token\"", "\":\"", "\";\"",
  "\"{\"", "\"}\"", "\"[\"", "\"]\"", "\"(\"", "\")\"", "\"?\"",
  "\"end predicate\"", "\",\"", "\"$#\"", "\"=\"", "\"==\"", "\"!=\"",
  "\"<=\"", "\">=\"", "\"<<\"", "\">>\"", "\"<\"", "\">\"", "\"&&\"",
  "\"||\"", "\"+\"", "\"++\"", "\"<<=\"", "\">>=\"", "\"+=\"", "\"-=\"",
  "\"*=\"", "\"/=\"", "\"%=\"", "\"&=\"", "\"|=\"", "\"^=\"", "\"-\"",
  "\"--\"", "\"*\"", "\"/\"", "\"%\"", "\"&\"", "\"|\"", "\"^\"", "\"!\"",
  "\"~\"", "\".\"", "\"->\"", "\"struct\"", "\"union\"", "\"builtin\"",
  "\"call\"", "\"call_builtin\"", "\"integer type\"", "\"builtin type\"",
  "\"subprog\"", "\"sized type\"", "\"identifier\"", "\"path\"",
  "\"preprocessor directive\"", "\"struct definition\"", "\"enum\"",
  "\"string\"", "\"map\"", "\"variable\"", "\"positional parameter\"",
  "\"integer\"", "\"stack_mode\"", "\"config\"", "\"unroll\"", "\"while\"",
  "\"for\"", "\"return\"", "\"if\"", "\"else\"", "\"continue\"",
  "\"break\"", "\"sizeof\"", "\"offsetof\"", "\"let\"", "$accept",
  "program", "c_definitions", "type", "int_type", "pointer_type",
  "struct_type", "config", "config_block", "config_assign_stmt_list",
  "config_assign_stmt", "subprog", "subprog_args", "subprog_arg",
  "probes_and_subprogs", "probe", "attach_points", "attach_point",
  "attach_point_def", "pred", "param", "block", "stmt_list", "block_stmt",
  "expr_stmt", "jump_stmt", "loop_stmt", "for_stmt", "if_stmt",
  "block_or_if", "assign_stmt", "var_decl_stmt", "primary_expr",
  "postfix_expr", "tuple_access_expr", "unary_expr", "unary_op", "expr",
  "conditional_expr", "logical_or_expr", "logical_and_expr", "or_expr",
  "xor_expr", "and_expr", "equality_expr", "relational_expr", "shift_expr",
  "muli_expr", "addi_expr", "cast_expr", "sizeof_expr", "offsetof_expr",
  "int", "keyword", "ident", "struct_field", "external_name", "call",
  "map", "var", "map_or_var", "vargs", "compound_op", YY_NULLPTR
  };
#endif


#if YYDEBUG
  const short
  Parser::yyrline_[] =
  {
       0,   183,   183,   189,   190,   191,   192,   196,   197,   219,
     228,   237,   240,   243,   246,   247,   251,   268,   271,   275,
     276,   282,   283,   287,   288,   292,   296,   299,   305,   306,
     310,   314,   315,   316,   317,   321,   331,   344,   345,   349,
     353,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   378,   382,   383,   388,   399,   406,   407,   411,   412,
     413,   414,   418,   419,   420,   424,   425,   430,   434,   435,
     436,   437,   441,   442,   443,   447,   451,   452,   456,   457,
     461,   466,   467,   468,   469,   474,   482,   483,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   505,   507,
     508,   510,   512,   513,   514,   515,   516,   517,   519,   520,
     525,   531,   532,   533,   534,   536,   537,   541,   542,   543,
     544,   548,   552,   553,   558,   559,   563,   564,   568,   569,
     573,   574,   579,   580,   584,   585,   586,   590,   591,   592,
     593,   594,   598,   599,   600,   604,   605,   606,   607,   611,
     612,   613,   617,   618,   620,   621,   622,   626,   627,   631,
     633,   637,   638,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   658,   659,   660,   661,
     662,   663,   667,   668,   672,   673,   677,   678,   679,   680,
     681,   682,   683,   684,   685,   686,   690,   691,   702,   706,
     707,   711,   712,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   725
  };

  void
  Parser::yy_stack_print_ () const
  {
    *yycdebug_ << "Stack now";
    for (stack_type::const_iterator
           i = yystack_.begin (),
           i_end = yystack_.end ();
         i != i_end; ++i)
      *yycdebug_ << ' ' << int (i->state);
    *yycdebug_ << '\n';
  }

  void
  Parser::yy_reduce_print_ (int yyrule) const
  {
    int yylno = yyrline_[yyrule];
    int yynrhs = yyr2_[yyrule];
    // Print the symbols being reduced, and their result.
    *yycdebug_ << "Reducing stack by rule " << yyrule - 1
               << " (line " << yylno << "):\n";
    // The symbols being reduced.
    for (int yyi = 0; yyi < yynrhs; yyi++)
      YY_SYMBOL_PRINT ("   $" << yyi + 1 << " =",
                       yystack_[(yynrhs) - (yyi + 1)]);
  }
#endif // YYDEBUG


#line 4 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"
} //  bpftrace 
#line 3574 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/redhat-linux-build/parser.tab.cc"

#line 728 "/builddir/build/BUILD/bpftrace-0.23.5-build/bpftrace-0.23.5/src/parser.yy"


void bpftrace::Parser::error(const location &l, const std::string &m)
{
  driver.error(l, m);
}
